/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
{- Structure of the family:

                    Christine --- Antony  Maria --- Bill
                      /    \              |
                     /      \             |
       Monica --- John       Alice --- Frank
        /  \                   |
       /    \                  |
    Susan  Peter             Andrew
-}

&&(true,Y)  --> Y
&&(false,_) --> false

%% if(true, X) --> X

female(Christine)  -->  true
female(Maria)      -->  true
female(Monica)     -->  true
female(Alice)      -->  true
female(Susan)      -->  true

male(Antony)  -->  true
male(Bill)    -->  true
male(John)    -->  true
male(Frank)   -->  true
male(Peter)   -->  true
male(Andrew)  -->  true

married(Christine, Antony)  -->  true
married(Maria, Bill)        -->  true
married(Monica, John)       -->  true
married(Alice, Frank)       -->  true

mother(Christine, John)   -->  true
mother(Christine, Alice)  -->  true
mother(Maria, Frank)      -->  true
mother(Monica, Susan)     -->  true
mother(Monica, Peter)     -->  true
mother(Alice, Andrew)     -->  true


father(F, C)  -->  &&(married(M, F), mother(M, C))


grandfather(G,C) -->  &&(father(G,F), father(F,C))
grandfather(G,C) -->  &&(father(G,M), mother(M,C))

*/%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

opFixity(&&,3,right).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%:- block &&(?,?,?,-,?).
&&(A,B,E):-hnf(A,F),'&&_1'(F,B,E).

%%%:- block '&&_1'(-,?,?,?,?),'&&_1'(?,?,?,-,?).
'&&_1'('True',A,B):-hnf(A,B).
'&&_1'('False',_,'False').
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%:- block family_rel_female(?,?,-,?).
family_rel_female(A,D):-hnf(A,E),family_rel_female_1(E,D).

%%%:- block family_rel_female_1(?,?,-,?).
family_rel_female_1(family_rel_Christine,'True').
family_rel_female_1(family_rel_Maria,'True').
family_rel_female_1(family_rel_Monica,'True').
family_rel_female_1(family_rel_Alice,'True').
family_rel_female_1(family_rel_Susan,'True').

%%%:- block family_rel_male(?,?,-,?).
family_rel_male(A,D):-hnf(A,E),family_rel_male_1(E,D).

%%%:- block family_rel_male_1(?,?,-,?).
family_rel_male_1(family_rel_Antony,'True').
family_rel_male_1(family_rel_Bill,'True').
family_rel_male_1(family_rel_John,'True').
family_rel_male_1(family_rel_Frank,'True').
family_rel_male_1(family_rel_Peter,'True').
family_rel_male_1(family_rel_Andrew,'True').

%%%:- block family_rel_married(?,?,?,-,?).
family_rel_married(A,B,E):-hnf(A,F),family_rel_married_1(F,B,E).

%%%:- block family_rel_married_1(?,?,?,-,?).
family_rel_married_1(family_rel_Christine,A,D):-
hnf(A,E),family_rel_married_1_family_rel_Christine_1(E,D).

%%%:- block family_rel_married_1_family_rel_Christine_1(?,?,-,?).
family_rel_married_1_family_rel_Christine_1(family_rel_Antony,'True').
family_rel_married_1(family_rel_Maria,A,D):-
hnf(A,E),family_rel_married_1_family_rel_Maria_1(E,D).

%%%:- block family_rel_married_1_family_rel_Maria_1(?,?,-,?).
family_rel_married_1_family_rel_Maria_1(family_rel_Bill,'True').
family_rel_married_1(family_rel_Monica,A,D):-
hnf(A,E),family_rel_married_1_family_rel_Monica_1(E,D).

%%%:- block family_rel_married_1_family_rel_Monica_1(?,?,-,?).
family_rel_married_1_family_rel_Monica_1(family_rel_John,'True').
family_rel_married_1(family_rel_Alice,A,D):-
hnf(A,E),family_rel_married_1_family_rel_Alice_1(E,D).

%%%:- block family_rel_married_1_family_rel_Alice_1(?,?,-,?).
family_rel_married_1_family_rel_Alice_1(family_rel_Frank,'True').



%%%:- block family_rel_imarried(?,?,?,-,?).
family_rel_imarried(A,B,E):-hnf(A,FA),hnf(B,FB),family_rel_imarried_1(FA,FB,E).

%%%:- block family_rel_imarried_1(?,?,?,-,?).
family_rel_imarried_1(family_rel_Christine,family_rel_Antony,'True').
family_rel_imarried_1(family_rel_Maria,family_rel_Bill,'True').
family_rel_imarried_1(family_rel_Monica,family_rel_John,'True').
family_rel_imarried_1(family_rel_Alice,family_rel_Frank,'True').



%%%:- block family_rel_mother(?,?,?,-,?).
family_rel_mother(A,B,E):-hnf(A,F),family_rel_mother_1(F,B,E).

%%%:- block family_rel_mother_1(?,?,?,-,?).
family_rel_mother_1(family_rel_Christine,A,D):-
hnf(A,E),family_rel_mother_1_family_rel_Christine_1(E,D).

%%%:- block family_rel_mother_1_family_rel_Christine_1(?,?,-,?).
family_rel_mother_1_family_rel_Christine_1(family_rel_John,'True').
family_rel_mother_1_family_rel_Christine_1(family_rel_Alice,'True').
family_rel_mother_1(family_rel_Maria,A,D):-
hnf(A,E),family_rel_mother_1_family_rel_Maria_1(E,D).

%%%:- block family_rel_mother_1_family_rel_Maria_1(?,?,-,?).
family_rel_mother_1_family_rel_Maria_1(family_rel_Frank,'True').
family_rel_mother_1(family_rel_Monica,A,D):-
hnf(A,E),family_rel_mother_1_family_rel_Monica_1(E,D).

%%%:- block family_rel_mother_1_family_rel_Monica_1(?,?,-,?).
family_rel_mother_1_family_rel_Monica_1(family_rel_Susan,'True').
family_rel_mother_1_family_rel_Monica_1(family_rel_Peter,'True').
family_rel_mother_1(family_rel_Alice,A,D):-
hnf(A,E),family_rel_mother_1_family_rel_Alice_1(E,D).

%%%:- block family_rel_mother_1_family_rel_Alice_1(?,?,-,?).
family_rel_mother_1_family_rel_Alice_1(family_rel_Andrew,'True').

%%%:- block family_rel_imother(?,?,?,-,?).
family_rel_imother(A,B,E):-hnf(A,FA),hnf(B,FB),family_rel_imother_1(FA,FB,E).

%%%:- block family_rel_imother_1(?,?,?,-,?).
family_rel_imother_1(family_rel_Christine,family_rel_John,'True').
family_rel_imother_1(family_rel_Christine,family_rel_Alice,'True').
family_rel_imother_1(family_rel_Maria,family_rel_Frank,'True').
family_rel_imother_1(family_rel_Monica,family_rel_Susan,'True').
family_rel_imother_1(family_rel_Monica,family_rel_Peter,'True').
family_rel_imother_1(family_rel_Alice,family_rel_Andrew,'True').


%%%:- block family_rel_father(?,?,?,-,?).
family_rel_father(A,B,E):-
hnf(&&(family_rel_married(X,A),family_rel_mother(X,B)),E).

%%%:- block family_rel_ifather(?,?,?,-,?).
family_rel_ifather(A,B,E):-
hnf(&&(family_rel_imarried(X,A),family_rel_imother(X,B)),E).


%%%:- block family_rel_grandfather(?,?,?,-,?).
family_rel_grandfather(A,B,E):-
hnf(&&(family_rel_father(A,X),family_rel_father(X,B)),E).
family_rel_grandfather(A,B,E):-
hnf(&&(family_rel_father(A,X),family_rel_mother(X,B)),E).

%%%:- block family_rel_igrandfather(?,?,?,-,?).
family_rel_igrandfather(A,B,E):-
hnf(&&(family_rel_ifather(A,X),family_rel_ifather(X,B)),E).
family_rel_igrandfather(A,B,E):-
hnf(&&(family_rel_ifather(A,X),family_rel_imother(X,B)),E).


%%%:-block hnf(?,?,-,?).
hnf(A,B):-var(A),!,B=A.
hnf(&&(A,B),E):-!,&&(A,B,E).
%hnf(if(A,B),F):-!,if(A,B,F).
hnf(family_rel_female(A),D):-!,family_rel_female(A,D).
hnf(family_rel_male(A),D):-!,family_rel_male(A,D).
%%%
hnf(family_rel_married(A,B),E):-!,family_rel_married(A,B,E).
hnf(family_rel_imarried(A,B),E):-!,family_rel_imarried(A,B,E).
%%%
hnf(family_rel_mother(A,B),E):-!,family_rel_mother(A,B,E).
hnf(family_rel_imother(A,B),E):-!,family_rel_imother(A,B,E).
%%%
hnf(family_rel_father(A,B),E):-!,family_rel_father(A,B,E).
hnf(family_rel_ifather(A,B),E):-!,family_rel_ifather(A,B,E).
%%%
hnf(family_rel_grandfather(A,B),E):-!,family_rel_grandfather(A,B,E).
hnf(family_rel_igrandfather(A,B),E):-!,family_rel_igrandfather(A,B,E).
%%%
hnf(A,A).


%%%%%%%%%%%%
%%% block nf
nf(A,B):-hnf(A,E),nf_hnf(E,B).

%%% block nf_hnf
nf_hnf(A,B):-var(A),!,B=A.
nf_hnf('True','True'):-!.
nf_hnf('False','False'):-!.
nf_hnf(family_rel_Christine,family_rel_Christine).
nf_hnf(family_rel_Maria,family_rel_Maria).
nf_hnf(family_rel_Monica,family_rel_Monica).
nf_hnf(family_rel_Alice,family_rel_Alice).
nf_hnf(family_rel_Susan,family_rel_Susan).
nf_hnf(family_rel_Antony,family_rel_Antony).
nf_hnf(family_rel_Bill,family_rel_Bill).
nf_hnf(family_rel_John,family_rel_John).
nf_hnf(family_rel_Frank,family_rel_Frank).
nf_hnf(family_rel_Peter,family_rel_Peter).
nf_hnf(family_rel_Andrew,family_rel_Andrew).



%%%/*************** SICSTUS
% This is how time and space are measured.
stat_start :- garbage_collect, nogc, statistics(runtime,_).
stat_end(Time) :-
        statistics(runtime,[_,MSec]), Time is MSec/1000,
        statistics(global_stack,[Bytes,_]), Mb is Bytes/1000000,
        width(WT,Time), format("Time ~*c~2f sec   ", [WT, 0' , Time]),
        width(WM,Mb), format("Garb ~*c~3f Mb   ", [WM, 0' , Mb]),
        nl.

% statistics
width(0,X) :- X>=10, !.
width(1,_).
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

eval(Computation):- nf(Computation,_), fail.
eval(_).


%% g(Input,Input)
%% V is the numer times we want to run the Computation,
g(0,_).
g(V,Computation):- eval(Computation), NewV is V-1, g(NewV,Computation).

%% g0(Input,Output)
%% V is the numer times we want to run the computation,
%% T is the runtime for this computation.
g0(V,T):- write('goal 0: '), stat_start, g(V,_), stat_end(T).

%% g1(Input,Output)
%% Idem
g1(V,T):- write('goal 1: gf  ..'), stat_start,
	g(V,family_rel_grandfather(_,_)), stat_end(T).

%% g2(Input,Output)
%% Idem
g2(V,T):- write('goal 2: igf ..'), stat_start,
	g(V,family_rel_igrandfather(_,_)), stat_end(T).

allgoals:- V = 1000,g0(V,T0),g1(V,T1),g2(V,T2),
		Sup is (((T1-T0)-(T2-T0))/(T1-T0))*100,
		write('Speedup = '), write(Sup), write('%'), nl.


%%%***********************************************************************/

/**************** SWI-ROLOG

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% T1 is the start time
stat_start(T1) :- T1 is cputime.

%% stat_end(Input,Output)
%% T1 is the start time and T is the temporal cost of the whole computation,
stat_end(T1,T) :-
	T2 is cputime, T is T2-T1, write('T= '), write(T),
        nl.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

eval(Computation):- nf(Computation,_), fail.
eval(_).


%% g(Input,Input)
%% V is the numer times we want to run the Computation,
g(0,_).
g(V,Computation):- eval(Computation), NewV is V-1, g(NewV,Computation).

%% g0(Input,Output)
%% V is the numer times we want to run the computation,
%% T is the runtime for this computation.
g0(V,T):- write('goal 0: '), stat_start(T1), g(V,_), stat_end(T1,T).

%% g1(Input,Output)
%% Idem
g1(V,T):- write('goal 1:  gf ..'), stat_start(T1),
	g(V,family_rel_grandfather(_,_)), stat_end(T1,T).

%% g2(Input,Output)
%% Idem
g2(V,T):- write('goal 2: igf ..'), stat_start(T1),
	g(V,family_rel_igrandfather(_,_)), stat_end(T1,T).

allgoals:- V = 100000,g0(V,T0),g1(V,T1),g2(V,T2),
		Sup is (((T1-T0)-(T2-T0))/(T1-T0))*100,
		write('Speedup = '), write(Sup), write('%'), nl.



***********************************************************************/
