:-prolog_flag(single_var_warnings,A,off).
:-prolog_flag(redefine_warnings,A,off).

opFixity(+,6,left).
opFixity(-,6,left).
opFixity(*,7,left).
opFixity(div,7,left).
opFixity(mod,7,left).
opFixity(==,4,non).
opFixity(<,4,non).
opFixity(>,4,non).
opFixity(<=,4,non).
opFixity(>=,4,non).
opFixity(=:=,4,non).
opFixity(&,0,right).
opFixity(>>,1,left).
opFixity(>>=,1,left).
opFixity('.',9,right).
opFixity($,0,right).
opFixity(&&,3,right).
opFixity('||',2,right).
opFixity(/=,4,non).
opFixity(++,5,right).
opFixity('!!',9,left).
opFixity(&>,0,right).

:- block '$comp'(?,?,?,?,-,?).
'$comp'(A,B,C,D,E,F):-hnf(apply(prelude_lambda0_1663(A,B),C),D,E,F).

:- block id(?,?,-,?).
id(A,B,C,D):-hnf(A,B,C,D).

:- block const(?,?,?,-,?).
const(A,B,C,D,E):-hnf(A,C,D,E).

:- block curry(?,?,?,?,-,?).
curry(A,B,C,D,E,F):-hnf(apply(A,'(,)'(B,C)),D,E,F).

:- block uncurry(?,?,?,-,?).
uncurry(A,B,C,D,E):-hnf(B,F,D,G),uncurry_2(F,A,C,G,E).

:- block uncurry_2(-,?,?,?,?),uncurry_2(?,?,?,-,?).
uncurry_2('(,)'(A,B),C,D,E,F):-hnf(apply(apply(C,A),B),D,E,F).

:- block flip(?,?,?,?,-,?).
flip(A,B,C,D,E,F):-hnf(apply(apply(A,C),B),D,E,F).

:- block $(?,?,?,-,?).
$(A,B,C,D,E):-hnf(apply(A,B),C,D,E).

:- block &&(?,?,?,-,?).
&&(A,B,C,D,E):-hnf(A,F,D,G),'&&_1'(F,B,C,G,E).

:- block '&&_1'(-,?,?,?,?),'&&_1'(?,?,?,-,?).
'&&_1'('True',A,B,C,D):-hnf(A,B,C,D).
'&&_1'('False',A,'False',B,B).

:- block '||'(?,?,?,-,?).
'||'(A,B,C,D,E):-hnf(A,F,D,G),'||_1'(F,B,C,G,E).

:- block '||_1'(-,?,?,?,?),'||_1'(?,?,?,-,?).
'||_1'('True',A,'True',B,B).
'||_1'('False',A,B,C,D):-hnf(A,B,C,D).

:- block not(?,?,-,?).
not(A,B,C,D):-hnf(A,E,C,F),not_1(E,B,F,D).

:- block not_1(-,?,?,?),not_1(?,?,-,?).
not_1('True','False',A,A).
not_1('False','True',A,A).

:- block otherwise(?,-,?).
otherwise('True',A,A).

:- block if_then_else(?,?,?,?,-,?).
if_then_else(A,B,C,D,E,F):-hnf(A,G,E,H),if_then_else_1(G,B,C,D,H,F).

:- block if_then_else_1(-,?,?,?,?,?),if_then_else_1(?,?,?,?,-,?).
if_then_else_1('True',A,B,C,D,E):-hnf(A,C,D,E).
if_then_else_1('False',A,B,C,D,E):-hnf(B,C,D,E).

:- block /=(?,?,?,-,?).
/=(A,B,C,D,E):-not(A==B,C,D,E).

:- block fst(?,?,-,?).
fst(A,B,C,D):-hnf(A,E,C,F),fst_1(E,B,F,D).

:- block fst_1(-,?,?,?),fst_1(?,?,-,?).
fst_1('(,)'(A,B),C,D,E):-hnf(A,C,D,E).

:- block snd(?,?,-,?).
snd(A,B,C,D):-hnf(A,E,C,F),snd_1(E,B,F,D).

:- block snd_1(-,?,?,?),snd_1(?,?,-,?).
snd_1('(,)'(A,B),C,D,E):-hnf(B,C,D,E).

:- block head(?,?,-,?).
head(A,B,C,D):-hnf(A,E,C,F),head_1(E,B,F,D).

:- block head_1(-,?,?,?),head_1(?,?,-,?).
head_1([A|B],C,D,E):-hnf(A,C,D,E).

:- block tail(?,?,-,?).
tail(A,B,C,D):-hnf(A,E,C,F),tail_1(E,B,F,D).

:- block tail_1(-,?,?,?),tail_1(?,?,-,?).
tail_1([A|B],C,D,E):-hnf(B,C,D,E).

:- block null(?,?,-,?).
null(A,B,C,D):-hnf(A,E,C,F),null_1(E,B,F,D).

:- block null_1(-,?,?,?),null_1(?,?,-,?).
null_1([],'True',A,A).
null_1([A|B],'False',C,C).

:- block ++(?,?,?,-,?).
++(A,B,C,D,E):-hnf(A,F,D,G),'++_1'(F,B,C,G,E).

:- block '++_1'(-,?,?,?,?),'++_1'(?,?,?,-,?).
'++_1'([],A,B,C,D):-hnf(A,B,C,D).
'++_1'([A|B],C,[A|++(B,C)],D,D).

:- block length(?,?,-,?).
length(A,B,C,D):-hnf(A,E,C,F),length_1(E,B,F,D).

:- block length_1(-,?,?,?),length_1(?,?,-,?).
length_1([],0,A,A).
length_1([A|B],C,D,E):-hnf(1+length(B),C,D,E).

:- block '!!'(?,?,?,-,?).
'!!'(A,B,C,D,E):-hnf(A,F,D,G),'!!_1'(F,B,C,G,E).

:- block '!!_1'(-,?,?,?,?),'!!_1'(?,?,?,-,?).
'!!_1'([A|B],C,D,E,F):-if_then_else(share(C,G,H)>0,'!!'(B,share(C,G,H)-1),A,D,E,F).

:- block map(?,?,?,-,?).
map(A,B,C,D,E):-hnf(B,F,D,G),map_2(F,A,C,G,E).

:- block map_2(-,?,?,?,?),map_2(?,?,?,-,?).
map_2([],A,[],B,B).
map_2([A|B],C,[apply(share(C,D,E),A)|map(share(C,D,E),B)],F,F).

:- block foldl(?,?,?,?,-,?).
foldl(A,B,C,D,E,F):-hnf(C,G,E,H),foldl_3(G,A,B,D,H,F).

:- block foldl_3(-,?,?,?,?,?),foldl_3(?,?,?,?,-,?).
foldl_3([],A,B,C,D,E):-hnf(B,C,D,E).
foldl_3([A|B],C,D,E,F,G):-foldl(share(C,H,I),apply(apply(share(C,H,I),D),A),B,E,F,G).

:- block foldl1(?,?,?,-,?).
foldl1(A,B,C,D,E):-hnf(B,F,D,G),foldl1_2(F,A,C,G,E).

:- block foldl1_2(-,?,?,?,?),foldl1_2(?,?,?,-,?).
foldl1_2([A|B],C,D,E,F):-foldl(C,A,B,D,E,F).

:- block foldr(?,?,?,?,-,?).
foldr(A,B,C,D,E,F):-hnf(C,G,E,H),foldr_3(G,A,B,D,H,F).

:- block foldr_3(-,?,?,?,?,?),foldr_3(?,?,?,?,-,?).
foldr_3([],A,B,C,D,E):-hnf(B,C,D,E).
foldr_3([A|B],C,D,E,F,G):-hnf(apply(apply(share(C,H,I),A),foldr(share(C,H,I),D,B)),E,F,G).

:- block foldr1(?,?,?,-,?).
foldr1(A,B,C,D,E):-hnf(B,F,D,G),foldr1_2(F,A,C,G,E).

:- block foldr1_2(-,?,?,?,?),foldr1_2(?,?,?,-,?).
foldr1_2([A|B],C,D,E,F):-hnf(B,G,E,H),'foldr1_2_._2'(G,A,C,D,H,F).

:- block 'foldr1_2_._2'(-,?,?,?,?,?),'foldr1_2_._2'(?,?,?,?,-,?).
'foldr1_2_._2'([],A,B,C,D,E):-hnf(A,C,D,E).
'foldr1_2_._2'([A|B],C,D,E,F,G):-hnf(apply(apply(share(D,H,I),C),foldr1(share(D,H,I),[A|B])),E,F,G).

:- block filter(?,?,?,-,?).
filter(A,B,C,D,E):-hnf(B,F,D,G),filter_2(F,A,C,G,E).

:- block filter_2(-,?,?,?,?),filter_2(?,?,?,-,?).
filter_2([],A,[],B,B).
filter_2([A|B],C,D,E,F):-if_then_else(apply(share(C,G,H),share(A,I,J)),[share(A,I,J)|filter(share(C,G,H),share(B,K,L))],filter(share(C,G,H),share(B,K,L)),D,E,F).

:- block zip(?,?,?,-,?).
zip(A,B,C,D,E):-hnf(A,F,D,G),zip_1(F,B,C,G,E).

:- block zip_1(-,?,?,?,?),zip_1(?,?,?,-,?).
zip_1([],A,[],B,B).
zip_1([A|B],C,D,E,F):-hnf(C,G,E,H),'zip_1_._3'(G,A,B,D,H,F).

:- block 'zip_1_._3'(-,?,?,?,?,?),'zip_1_._3'(?,?,?,?,-,?).
'zip_1_._3'([],A,B,[],C,C).
'zip_1_._3'([A|B],C,D,['(,)'(C,A)|zip(D,B)],E,E).

:- block zip3(?,?,?,?,-,?).
zip3(A,B,C,D,E,F):-hnf(A,G,E,H),zip3_1(G,B,C,D,H,F).

:- block zip3_1(-,?,?,?,?,?),zip3_1(?,?,?,?,-,?).
zip3_1([],A,B,[],C,C).
zip3_1([A|B],C,D,E,F,G):-hnf(C,H,F,I),'zip3_1_._3'(H,A,B,D,E,I,G).

:- block 'zip3_1_._3'(-,?,?,?,?,?,?),'zip3_1_._3'(?,?,?,?,?,-,?).
'zip3_1_._3'([],A,B,C,[],D,D).
'zip3_1_._3'([A|B],C,D,E,F,G,H):-hnf(E,I,G,J),'zip3_1_._3_._5'(I,A,B,C,D,F,J,H).

:- block 'zip3_1_._3_._5'(-,?,?,?,?,?,?,?),'zip3_1_._3_._5'(?,?,?,?,?,?,-,?).
'zip3_1_._3_._5'([],A,B,C,D,[],E,E).
'zip3_1_._3_._5'([A|B],C,D,E,F,['(,,)'(E,C,A)|zip3(F,D,B)],G,G).

:- block unzip(?,?,-,?).
unzip(A,B,C,D):-hnf(A,E,C,F),unzip_1(E,B,F,D).

:- block unzip_1(-,?,?,?),unzip_1(?,?,-,?).
unzip_1([],'(,)'([],[]),A,A).
unzip_1([A|B],C,D,E):-hnf(A,F,D,G),'unzip_1_._1'(F,B,C,G,E).

:- block 'unzip_1_._1'(-,?,?,?,?),'unzip_1_._1'(?,?,?,-,?).
'unzip_1_._1'('(,)'(A,B),C,D,E,F):-prelude_lambda1_1664(A,B,unzip(C),D,E,F).

:- block unzip3(?,?,-,?).
unzip3(A,B,C,D):-hnf(A,E,C,F),unzip3_1(E,B,F,D).

:- block unzip3_1(-,?,?,?),unzip3_1(?,?,-,?).
unzip3_1([],'(,,)'([],[],[]),A,A).
unzip3_1([A|B],C,D,E):-hnf(A,F,D,G),'unzip3_1_._1'(F,B,C,G,E).

:- block 'unzip3_1_._1'(-,?,?,?,?),'unzip3_1_._1'(?,?,?,-,?).
'unzip3_1_._1'('(,,)'(A,B,C),D,E,F,G):-prelude_lambda2_1665(A,B,C,unzip3(D),E,F,G).

:- block concat(?,?,-,?).
concat(A,B,C,D):-foldr(++,[],A,B,C,D).

:- block concatMap(?,?,?,-,?).
concatMap(A,B,C,D,E):-hnf(apply('$comp'(concat,map(A)),B),C,D,E).

:- block iterate(?,?,?,-,?).
iterate(A,B,[share(B,C,D)|iterate(share(A,E,F),apply(share(A,E,F),share(B,C,D)))],G,G).

:- block repeat(?,?,-,?).
repeat(A,[share(A,B,C)|repeat(share(A,B,C))],D,D).

:- block replicate(?,?,?,-,?).
replicate(A,B,C,D,E):-take(A,repeat(B),C,D,E).

:- block take(?,?,?,-,?).
take(A,B,C,D,E):-if_then_else(share(A,F,G)==0,[],takep_343(share(A,F,G),B),C,D,E).

:- block drop(?,?,?,-,?).
drop(A,B,C,D,E):-if_then_else(share(A,F,G)==0,share(B,H,I),dropp_350(share(A,F,G),share(B,H,I)),C,D,E).

:- block splitAt(?,?,?,-,?).
splitAt(A,B,C,D,E):-if_then_else(share(A,F,G)==0,'(,)'([],share(B,H,I)),splitAtp_357(share(A,F,G),share(B,H,I)),C,D,E).

:- block takeWhile(?,?,?,-,?).
takeWhile(A,B,C,D,E):-hnf(B,F,D,G),takeWhile_2(F,A,C,G,E).

:- block takeWhile_2(-,?,?,?,?),takeWhile_2(?,?,?,-,?).
takeWhile_2([],A,[],B,B).
takeWhile_2([A|B],C,D,E,F):-if_then_else(apply(share(C,G,H),share(A,I,J)),[share(A,I,J)|takeWhile(share(C,G,H),B)],[],D,E,F).

:- block dropWhile(?,?,?,-,?).
dropWhile(A,B,C,D,E):-hnf(B,F,D,G),dropWhile_2(F,A,C,G,E).

:- block dropWhile_2(-,?,?,?,?),dropWhile_2(?,?,?,-,?).
dropWhile_2([],A,[],B,B).
dropWhile_2([A|B],C,D,E,F):-if_then_else(apply(share(C,G,H),share(A,I,J)),dropWhile(share(C,G,H),share(B,K,L)),[share(A,I,J)|share(B,K,L)],D,E,F).

:- block span(?,?,?,-,?).
span(A,B,C,D,E):-hnf(B,F,D,G),span_2(F,A,C,G,E).

:- block span_2(-,?,?,?,?),span_2(?,?,?,-,?).
span_2([],A,'(,)'([],[]),B,B).
span_2([A|B],C,D,E,F):-if_then_else(apply(share(C,G,H),share(A,I,J)),prelude_lambda4_1667(share(A,I,J),span(share(C,G,H),share(B,K,L))),'(,)'([],[share(A,I,J)|share(B,K,L)]),D,E,F).

:- block break(?,?,?,-,?).
break(A,B,C,D,E):-hnf(apply(span('$comp'(not,A)),B),C,D,E).

:- block lines(?,?,-,?).
lines(A,B,C,D):-hnf(A,E,C,F),lines_1(E,B,F,D).

:- block lines_1(-,?,?,?),lines_1(?,?,-,?).
lines_1([],[],A,A).
lines_1([A|B],C,D,E):-prelude_lambda6_1669(splitline_381([A|B]),C,D,E).

:- block unlines(?,?,-,?).
unlines(A,B,C,D):-hnf(apply(concatMap(prelude_lambda7_1670),A),B,C,D).

:- block reverse(?,?,-,?).
reverse(A,B,C,D):-hnf(apply(foldl(flip('.'),[]),A),B,C,D).

:- block enumFrom(?,?,-,?).
enumFrom(A,[share(A,B,C)|enumFrom(share(A,B,C)+1)],D,D).

:- block enumFromThen(?,?,?,-,?).
enumFromThen(A,B,C,D,E):-iterate(prelude_lambda8_1671(B,share(A,F,G)),share(A,F,G),C,D,E).

:- block enumFromTo(?,?,?,-,?).
enumFromTo(A,B,C,D,E):-if_then_else(share(A,F,G)>share(B,H,I),[],[share(A,F,G)|enumFromTo(share(A,F,G)+1,share(B,H,I))],C,D,E).

:- block enumFromThenTo(?,?,?,?,-,?).
enumFromThenTo(A,B,C,D,E,F):-takeWhile(p_399(share(B,G,H),share(A,I,J),C),enumFromThen(share(A,I,J),share(B,G,H)),D,E,F).

:- block &>(?,?,?,-,?).
&>(A,B,C,D,E):-hnf(guardedexpr(A,B),C,D,E).

:- block failed(?,-,?).
failed(A,B,C):-hnf(guardedexpr(1=:=2,D),A,B,C).

:- block maybe(?,?,?,?,-,?).
maybe(A,B,C,D,E,F):-hnf(C,G,E,H),maybe_3(G,A,B,D,H,F).

:- block maybe_3(-,?,?,?,?,?),maybe_3(?,?,?,?,-,?).
maybe_3('Nothing',A,B,C,D,E):-hnf(A,C,D,E).
maybe_3('Just'(A),B,C,D,E,F):-hnf(apply(C,A),D,E,F).

:- block either(?,?,?,?,-,?).
either(A,B,C,D,E,F):-hnf(C,G,E,H),either_3(G,A,B,D,H,F).

:- block either_3(-,?,?,?,?,?),either_3(?,?,?,?,-,?).
either_3('Left'(A),B,C,D,E,F):-hnf(apply(B,A),D,E,F).
either_3('Right'(A),B,C,D,E,F):-hnf(apply(C,A),D,E,F).

:- block putStr(?,?,-,?).
putStr(A,B,C,D):-hnf(A,E,C,F),putStr_1(E,B,F,D).

:- block putStr_1(-,?,?,?),putStr_1(?,?,-,?).
putStr_1([],A,B,C):-hnf(done,A,B,C).
putStr_1([A|B],C,D,E):-hnf(putChar(A)>>putStr(B),C,D,E).

:- block putStrLn(?,?,-,?).
putStrLn(A,B,C,D):-hnf(putStr(A)>>putChar(10),B,C,D).

:- block getLine(?,-,?).
getLine(A,B,C):-hnf(>>=(getChar,prelude_lambda9_1672),A,B,C).

:- block print(?,?,-,?).
print(A,B,C,D):-putStrLn(show(A),B,C,D).

:- block doSolve(?,?,-,?).
doSolve(A,B,C,D):-hnf(guardedexpr(A,done),B,C,D).

:- block inject(?,?,?,?,-,?).
inject(A,B,C,D,E,F):-hnf(apply(prelude_lambda10_1673(B,A),C),D,E,F).

:- block all(?,?,-,?).
all(A,B,C,D):-evalall_428(try(A),B,C,D).

:- block all2(?,?,-,?).
all2(A,B,C,D):-evalResult_445(try(A),B,C,D).

:- block once(?,?,?,-,?).
once(A,B,C,D,E):-hnf(apply(head(all(A)),B),C,D,E).

:- block one(?,?,-,?).
one(A,B,C,D):-dfs(prelude_lambda11_1674(A),B,C,D).

:- block condSearch(?,?,?,-,?).
condSearch(A,B,C,D,E):-one(prelude_lambda12_1675(A,B),C,D,E).

:- block best(?,?,?,-,?).
best(A,B,C,D,E):-bestHelp([],try(A),[],B,C,D,E).

:- block bestHelp(?,?,?,?,?,-,?).
bestHelp(A,B,C,D,E,F,G):-hnf(A,H,F,I),bestHelp_1(H,B,C,D,E,I,G).

:- block bestHelp_1(-,?,?,?,?,?,?),bestHelp_1(?,?,?,?,?,-,?).
bestHelp_1([],A,B,C,D,E,F):-hnf(A,G,E,H),'bestHelp_1_[]_1'(G,B,C,D,H,F).

:- block 'bestHelp_1_[]_1'(-,?,?,?,?,?),'bestHelp_1_[]_1'(?,?,?,?,-,?).
'bestHelp_1_[]_1'([],A,B,C,D,E):-hnf(A,C,D,E).
'bestHelp_1_[]_1'([A|B],C,D,E,F,G):-evalB(try(constrain(A,share(C,H,I),share(D,J,K))),B,share(C,H,I),share(D,J,K),E,F,G).
bestHelp_1([A|B],C,D,E,F,G,H):-evalA(try(A),B,C,D,E,F,G,H).

:- block evalB(?,?,?,?,?,-,?).
evalB(A,B,C,D,E,F,G):-hnf(A,H,F,I),evalB_1(H,B,C,D,E,I,G).

:- block evalB_1(-,?,?,?,?,?,?),evalB_1(?,?,?,?,?,-,?).
evalB_1([],A,B,C,D,E,F):-bestHelp([],A,B,C,D,E,F).
evalB_1([A|B],C,D,E,F,G,H):-hnf(B,I,G,J),'evalB_1_._2'(I,A,C,D,E,F,J,H).

:- block 'evalB_1_._2'(-,?,?,?,?,?,?,?),'evalB_1_._2'(?,?,?,?,?,?,-,?).
'evalB_1_._2'([],A,B,C,D,E,F,G):-bestHelp([],B,[A],D,E,F,G).
'evalB_1_._2'([A|B],C,D,E,F,G,H,I):-bestHelp([C,A|B],D,E,F,G,H,I).

:- block evalA(?,?,?,?,?,?,-,?).
evalA(A,B,C,D,E,F,G,H):-hnf(A,I,G,J),evalA_1(I,B,C,D,E,F,J,H).

:- block evalA_1(-,?,?,?,?,?,?,?),evalA_1(?,?,?,?,?,?,-,?).
evalA_1([],A,B,C,D,E,F,G):-bestHelp(A,B,C,D,E,F,G).
evalA_1([A|B],C,D,E,F,G,H,I):-hnf(B,J,H,K),'evalA_1_._2'(J,A,C,D,E,F,G,K,I).

:- block 'evalA_1_._2'(-,?,?,?,?,?,?,?,?),'evalA_1_._2'(?,?,?,?,?,?,?,-,?).
'evalA_1_._2'([],A,B,C,D,E,F,G,H):-bestHelp([],++(B,C),[A],E,F,G,H).
'evalA_1_._2'([A|B],C,D,E,F,G,H,I,J):-bestHelp(++([C,A|B],D),E,F,G,H,I,J).

:- block constrain(?,?,?,?,?,-,?).
constrain(A,B,C,D,E,F,G):-hnf(B,H,F,I),constrain_2(H,A,C,D,E,I,G).

:- block constrain_2(?,?,?,?,?,-,?).
constrain_2([],A,B,C,D,E,F):-hnf(apply(A,C),D,E,F).
constrain_2([A|B],C,D,E,F,G,H):-hnf(B,I,G,J),'constrain_2_._2'(I,A,C,D,E,F,J,H).

:- block 'constrain_2_._2'(?,?,?,?,?,?,-,?).
'constrain_2_._2'([],A,B,C,D,E,F,G):-hnf(apply(inject(B,prelude_lambda13_1676(A,C)),D),E,F,G).

:- block dfs(?,?,-,?).
dfs(A,B,C,D):-evaldfs_510(try(A),B,C,D).

:- block browseList(?,?,-,?).
browseList(A,B,C,D):-hnf(A,E,C,F),browseList_1(E,B,F,D).

:- block browseList_1(-,?,?,?),browseList_1(?,?,-,?).
browseList_1([],A,B,C):-hnf(done,A,B,C).
browseList_1([A|B],C,D,E):-hnf(browse(A)>>putChar(10)>>browseList(B),C,D,E).

:- block unpack(?,?,-,?).
unpack(A,B,C,D):-hnf(guardedexpr(apply(A,share(E,F,G)),share(E,F,G)),B,C,D).

:- block prelude_lambda0_1663(?,?,?,?,-,?).
prelude_lambda0_1663(A,B,C,D,E,F):-hnf(apply(A,apply(B,C)),D,E,F).

:- block prelude_lambda1_1664(?,?,?,?,-,?).
prelude_lambda1_1664(A,B,C,D,E,F):-hnf(C,G,E,H),prelude_lambda1_1664_3(G,A,B,D,H,F).

:- block prelude_lambda1_1664_3(-,?,?,?,?,?),prelude_lambda1_1664_3(?,?,?,?,-,?).
prelude_lambda1_1664_3('(,)'(A,B),C,D,'(,)'([C|A],[D|B]),E,E).

:- block prelude_lambda2_1665(?,?,?,?,?,-,?).
prelude_lambda2_1665(A,B,C,D,E,F,G):-hnf(D,H,F,I),prelude_lambda2_1665_4(H,A,B,C,E,I,G).

:- block prelude_lambda2_1665_4(-,?,?,?,?,?,?),prelude_lambda2_1665_4(?,?,?,?,?,-,?).
prelude_lambda2_1665_4('(,,)'(A,B,C),D,E,F,'(,,)'([D|A],[E|B],[F|C]),G,G).

:- block takep_343(?,?,?,-,?).
takep_343(A,B,C,D,E):-hnf(B,F,D,G),takep_343_2(F,A,C,G,E).

:- block takep_343_2(-,?,?,?,?),takep_343_2(?,?,?,-,?).
takep_343_2([],A,[],B,B).
takep_343_2([A|B],C,[A|take(C-1,B)],D,D).

:- block dropp_350(?,?,?,-,?).
dropp_350(A,B,C,D,E):-hnf(B,F,D,G),dropp_350_2(F,A,C,G,E).

:- block dropp_350_2(-,?,?,?,?),dropp_350_2(?,?,?,-,?).
dropp_350_2([],A,[],B,B).
dropp_350_2([A|B],C,D,E,F):-drop(C-1,B,D,E,F).

:- block splitAtp_357(?,?,?,-,?).
splitAtp_357(A,B,C,D,E):-hnf(B,F,D,G),splitAtp_357_2(F,A,C,G,E).

:- block splitAtp_357_2(-,?,?,?,?),splitAtp_357_2(?,?,?,-,?).
splitAtp_357_2([],A,'(,)'([],[]),B,B).
splitAtp_357_2([A|B],C,D,E,F):-prelude_lambda3_1666(A,splitAt(C-1,B),D,E,F).

:- block prelude_lambda3_1666(?,?,?,-,?).
prelude_lambda3_1666(A,B,C,D,E):-hnf(B,F,D,G),prelude_lambda3_1666_2(F,A,C,G,E).

:- block prelude_lambda3_1666_2(-,?,?,?,?),prelude_lambda3_1666_2(?,?,?,-,?).
prelude_lambda3_1666_2('(,)'(A,B),C,'(,)'([C|A],B),D,D).

:- block prelude_lambda4_1667(?,?,?,-,?).
prelude_lambda4_1667(A,B,C,D,E):-hnf(B,F,D,G),prelude_lambda4_1667_2(F,A,C,G,E).

:- block prelude_lambda4_1667_2(-,?,?,?,?),prelude_lambda4_1667_2(?,?,?,-,?).
prelude_lambda4_1667_2('(,)'(A,B),C,'(,)'([C|A],B),D,D).

:- block splitline_381(?,?,-,?).
splitline_381(A,B,C,D):-hnf(A,E,C,F),splitline_381_1(E,B,F,D).

:- block splitline_381_1(-,?,?,?),splitline_381_1(?,?,-,?).
splitline_381_1([],'(,)'([],[]),A,A).
splitline_381_1([A|B],C,D,E):-if_then_else(share(A,F,G)==10,'(,)'([],share(B,H,I)),prelude_lambda5_1668(share(A,F,G),splitline_381(share(B,H,I))),C,D,E).

:- block prelude_lambda5_1668(?,?,?,-,?).
prelude_lambda5_1668(A,B,C,D,E):-hnf(B,F,D,G),prelude_lambda5_1668_2(F,A,C,G,E).

:- block prelude_lambda5_1668_2(-,?,?,?,?),prelude_lambda5_1668_2(?,?,?,-,?).
prelude_lambda5_1668_2('(,)'(A,B),C,'(,)'([C|A],B),D,D).

:- block prelude_lambda6_1669(?,?,-,?).
prelude_lambda6_1669(A,B,C,D):-hnf(A,E,C,F),prelude_lambda6_1669_1(E,B,F,D).

:- block prelude_lambda6_1669_1(-,?,?,?),prelude_lambda6_1669_1(?,?,-,?).
prelude_lambda6_1669_1('(,)'(A,B),[A|lines(B)],C,C).

:- block prelude_lambda7_1670(?,?,-,?).
prelude_lambda7_1670(A,B,C,D):- ++(A,[10],B,C,D).

:- block prelude_lambda8_1671(?,?,?,?,-,?).
prelude_lambda8_1671(A,B,C,D,E,F):-hnf(A-B+C,D,E,F).

:- block p_399(?,?,?,?,?,-,?).
p_399(A,B,C,D,E,F,G):-if_then_else(A>=B,<=(share(D,H,I),share(C,J,K)),share(D,H,I)>=share(C,J,K),E,F,G).

:- block getLineReturn_418(?,?,?,-,?).
getLineReturn_418(A,B,C,D,E):-hnf(return([A|B]),C,D,E).

:- block prelude_lambda9_1672(?,?,-,?).
prelude_lambda9_1672(A,B,C,D):-if_then_else(share(A,E,F)==10,return([]),>>=(getLine,getLineReturn_418(share(A,E,F))),B,C,D).

:- block prelude_lambda10_1673(?,?,?,?,-,?).
prelude_lambda10_1673(A,B,C,D,E,F):-hnf(&(apply(A,share(C,G,H)),apply(B,share(C,G,H))),D,E,F).

:- block evalall_428(?,?,-,?).
evalall_428(A,B,C,D):-hnf(A,E,C,F),evalall_428_1(E,B,F,D).

:- block evalall_428_1(-,?,?,?),evalall_428_1(?,?,-,?).
evalall_428_1([],[],A,A).
evalall_428_1([A|B],C,D,E):-hnf(B,F,D,G),'evalall_428_1_._2'(F,A,C,G,E).

:- block 'evalall_428_1_._2'(-,?,?,?,?),'evalall_428_1_._2'(?,?,?,-,?).
'evalall_428_1_._2'([],A,[A],B,B).
'evalall_428_1_._2'([A|B],C,D,E,F):-evalall3_430(try(C),[A|B],D,E,F).

:- block evalall2_429(?,?,-,?).
evalall2_429(A,B,C,D):-hnf(A,E,C,F),evalall2_429_1(E,B,F,D).

:- block evalall2_429_1(-,?,?,?),evalall2_429_1(?,?,-,?).
evalall2_429_1([],[],A,A).
evalall2_429_1([A|B],C,D,E):-evalall3_430(try(A),B,C,D,E).

:- block evalall3_430(?,?,?,-,?).
evalall3_430(A,B,C,D,E):-hnf(A,F,D,G),evalall3_430_1(F,B,C,G,E).

:- block evalall3_430_1(-,?,?,?,?),evalall3_430_1(?,?,?,-,?).
evalall3_430_1([],A,B,C,D):-evalall2_429(A,B,C,D).
evalall3_430_1([A|B],C,D,E,F):-hnf(B,G,E,H),'evalall3_430_1_._2'(G,A,C,D,H,F).

:- block 'evalall3_430_1_._2'(-,?,?,?,?,?),'evalall3_430_1_._2'(?,?,?,?,-,?).
'evalall3_430_1_._2'([],A,B,[A|evalall2_429(B)],C,C).
'evalall3_430_1_._2'([A|B],C,D,E,F,G):-evalall3_430(try(C),[A|++(B,D)],E,F,G).

:- block evalResult_445(?,?,-,?).
evalResult_445(A,B,C,D):-hnf(A,E,C,F),evalResult_445_1(E,B,F,D).

:- block evalResult_445_1(-,?,?,?),evalResult_445_1(?,?,-,?).
evalResult_445_1([],[],A,A).
evalResult_445_1([A|B],C,D,E):-hnf(B,F,D,G),'evalResult_445_1_._2'(F,A,C,G,E).

:- block 'evalResult_445_1_._2'(-,?,?,?,?),'evalResult_445_1_._2'(?,?,?,-,?).
'evalResult_445_1_._2'([],A,[A],B,B).
'evalResult_445_1_._2'([A|B],C,D,E,F):-concat(map(all2,[C,A|B]),D,E,F).

:- block prelude_lambda11_1674(?,?,?,-,?).
prelude_lambda11_1674(A,B,C,D,E):-hnf(B=:=tryone(A),C,D,E).

:- block prelude_lambda12_1675(?,?,?,?,-,?).
prelude_lambda12_1675(A,B,C,D,E,F):-hnf(&(apply(A,share(C,G,H)),apply(B,share(C,G,H))=:='True'),D,E,F).

:- block prelude_lambda13_1676(?,?,?,?,-,?).
prelude_lambda13_1676(A,B,C,D,E,F):-hnf(&(apply(A,share(G,H,I)),apply(apply(B,C),share(G,H,I))=:='True'),D,E,F).

:- block evaldfs_510(?,?,-,?).
evaldfs_510(A,B,C,D):-hnf(A,E,C,F),evaldfs_510_1(E,B,F,D).

:- block evaldfs_510_1(-,?,?,?),evaldfs_510_1(?,?,-,?).
evaldfs_510_1([],[],A,A).
evaldfs_510_1([A|B],C,D,E):-eval2_511(try(A),B,C,D,E).

:- block eval2_511(?,?,?,-,?).
eval2_511(A,B,C,D,E):-hnf(A,F,D,G),eval2_511_1(F,B,C,G,E).

:- block eval2_511_1(-,?,?,?,?),eval2_511_1(?,?,?,-,?).
eval2_511_1([],A,B,C,D):-evaldfs_510(A,B,C,D).
eval2_511_1([A|B],C,D,E,F):-hnf(B,G,E,H),'eval2_511_1_._2'(G,A,C,D,H,F).

:- block 'eval2_511_1_._2'(-,?,?,?,?,?),'eval2_511_1_._2'(?,?,?,?,-,?).
'eval2_511_1_._2'([],A,B,[A],C,C).
'eval2_511_1_._2'([A|B],C,D,E,F,G):-eval2_511(try(C),[A|++(B,D)],E,F,G).

:- block fun_geq(?,?,?,-,?).
fun_geq(A,B,C,D,E):-hnf(A,F,D,G),fun_geq_1(F,B,C,G,E).

:- block fun_geq_1(-,?,?,?,?),fun_geq_1(?,?,?,-,?).
fun_geq_1(fun_zero,A,B,C,D):-hnf(A,E,C,F),fun_geq_1_fun_zero_1(E,B,F,D).

:- block fun_geq_1_fun_zero_1(-,?,?,?),fun_geq_1_fun_zero_1(?,?,-,?).
fun_geq_1_fun_zero_1(fun_zero,'True',A,A).
fun_geq_1_fun_zero_1(fun_succ(A),'False',B,B).
fun_geq_1(fun_succ(A),B,C,D,E):-hnf(B,F,D,G),fun_geq_1_fun_succ_2(F,A,C,G,E).

:- block fun_geq_1_fun_succ_2(-,?,?,?,?),fun_geq_1_fun_succ_2(?,?,?,-,?).
fun_geq_1_fun_succ_2(fun_zero,A,'True',B,B).
fun_geq_1_fun_succ_2(fun_succ(A),B,C,D,E):-fun_geq(B,A,C,D,E).

:- block fun_cip(?,?,?,-,?).
fun_cip(A,B,C,D,E):-hnf(A,F,D,G),fun_cip_1(F,B,C,G,E).

:- block fun_cip_1(-,?,?,?,?),fun_cip_1(?,?,?,-,?).
fun_cip_1([],A,B,C,D):-hnf(A,E,C,F),'fun_cip_1_[]_1'(E,B,F,D).

:- block 'fun_cip_1_[]_1'(-,?,?,?),'fun_cip_1_[]_1'(?,?,-,?).
'fun_cip_1_[]_1'([],[],A,A).
fun_cip_1([A|B],C,D,E,F):-hnf(C,G,E,H),'fun_cip_1_._3'(G,A,B,D,H,F).

:- block 'fun_cip_1_._3'(-,?,?,?,?,?),'fun_cip_1_._3'(?,?,?,?,-,?).
'fun_cip_1_._3'([A|B],C,D,['(,)'(C,A)|fun_cip(D,B)],E,E).

:- block fun_cip3(?,?,?,?,-,?).
fun_cip3(A,B,C,D,E,F):-hnf(A,G,E,H),fun_cip3_1(G,B,C,D,H,F).

:- block fun_cip3_1(-,?,?,?,?,?),fun_cip3_1(?,?,?,?,-,?).
fun_cip3_1([],A,B,C,D,E):-hnf(A,F,D,G),'fun_cip3_1_[]_1'(F,B,C,G,E).

:- block 'fun_cip3_1_[]_1'(-,?,?,?,?),'fun_cip3_1_[]_1'(?,?,?,-,?).
'fun_cip3_1_[]_1'([],A,B,C,D):-hnf(A,E,C,F),'fun_cip3_1_[]_1_[]_1'(E,B,F,D).

:- block 'fun_cip3_1_[]_1_[]_1'(-,?,?,?),'fun_cip3_1_[]_1_[]_1'(?,?,-,?).
'fun_cip3_1_[]_1_[]_1'([],[],A,A).
fun_cip3_1([A|B],C,D,E,F,G):-hnf(C,H,F,I),'fun_cip3_1_._3'(H,A,B,D,E,I,G).

:- block 'fun_cip3_1_._3'(-,?,?,?,?,?,?),'fun_cip3_1_._3'(?,?,?,?,?,-,?).
'fun_cip3_1_._3'([A|B],C,D,E,F,G,H):-hnf(E,I,G,J),'fun_cip3_1_._3_._5'(I,A,B,C,D,F,J,H).

:- block 'fun_cip3_1_._3_._5'(-,?,?,?,?,?,?,?),'fun_cip3_1_._3_._5'(?,?,?,?,?,?,-,?).
'fun_cip3_1_._3_._5'([A|B],C,D,E,F,['(,,)'(E,C,A)|fun_cip3(F,D,B)],G,G).

:- block fun_xor(?,?,?,-,?).
fun_xor(A,B,C,D,E):-hnf(A,F,D,G),fun_xor_1(F,B,C,G,E).

:- block fun_xor_1(-,?,?,?,?),fun_xor_1(?,?,?,-,?).
fun_xor_1('True',A,B,C,D):-hnf(A,E,C,F),fun_xor_1_True_1(E,B,F,D).

:- block fun_xor_1_True_1(-,?,?,?),fun_xor_1_True_1(?,?,-,?).
fun_xor_1_True_1('True','False',A,A).
fun_xor_1_True_1('False','True',A,A).
fun_xor_1('False',A,B,C,D):-hnf(A,E,C,F),fun_xor_1_False_1(E,B,F,D).

:- block fun_xor_1_False_1(-,?,?,?),fun_xor_1_False_1(?,?,-,?).
fun_xor_1_False_1('True','True',A,A).
fun_xor_1_False_1('False','False',A,A).

:-block hnf(?,?,-,?).
hnf(A,B,C,C):-var(A),!,B=A.
hnf(share(A,B,C),D,E,F):-!,(nonvar(B)->C=D,E=F;hnf(A,G,E,F),(nonvar(G),(functor(G,'$io',1);functor(G,success,0))->D=G;propagateShare(G,D),B=eval,C=D)).
hnf('$comp'(A,B,C),D,E,F):-!,'$comp'(A,B,C,D,E,F).
hnf(id(A),B,C,D):-!,id(A,B,C,D).
hnf(const(A,B),C,D,E):-!,const(A,B,C,D,E).
hnf(curry(A,B,C),D,E,F):-!,curry(A,B,C,D,E,F).
hnf(uncurry(A,B),C,D,E):-!,uncurry(A,B,C,D,E).
hnf(flip(A,B,C),D,E,F):-!,flip(A,B,C,D,E,F).
hnf($(A,B),C,D,E):-!,$(A,B,C,D,E).
hnf(&&(A,B),C,D,E):-!,&&(A,B,C,D,E).
hnf('||'(A,B),C,D,E):-!,'||'(A,B,C,D,E).
hnf(not(A),B,C,D):-!,not(A,B,C,D).
hnf(otherwise,A,B,C):-!,otherwise(A,B,C).
hnf(if_then_else(A,B,C),D,E,F):-!,if_then_else(A,B,C,D,E,F).
hnf(/=(A,B),C,D,E):-!,/=(A,B,C,D,E).
hnf(fst(A),B,C,D):-!,fst(A,B,C,D).
hnf(snd(A),B,C,D):-!,snd(A,B,C,D).
hnf(head(A),B,C,D):-!,head(A,B,C,D).
hnf(tail(A),B,C,D):-!,tail(A,B,C,D).
hnf(null(A),B,C,D):-!,null(A,B,C,D).
hnf(++(A,B),C,D,E):-!,++(A,B,C,D,E).
hnf(length(A),B,C,D):-!,length(A,B,C,D).
hnf('!!'(A,B),C,D,E):-!,'!!'(A,B,C,D,E).
hnf(map(A,B),C,D,E):-!,map(A,B,C,D,E).
hnf(foldl(A,B,C),D,E,F):-!,foldl(A,B,C,D,E,F).
hnf(foldl1(A,B),C,D,E):-!,foldl1(A,B,C,D,E).
hnf(foldr(A,B,C),D,E,F):-!,foldr(A,B,C,D,E,F).
hnf(foldr1(A,B),C,D,E):-!,foldr1(A,B,C,D,E).
hnf(filter(A,B),C,D,E):-!,filter(A,B,C,D,E).
hnf(zip(A,B),C,D,E):-!,zip(A,B,C,D,E).
hnf(zip3(A,B,C),D,E,F):-!,zip3(A,B,C,D,E,F).
hnf(unzip(A),B,C,D):-!,unzip(A,B,C,D).
hnf(unzip3(A),B,C,D):-!,unzip3(A,B,C,D).
hnf(concat(A),B,C,D):-!,concat(A,B,C,D).
hnf(concatMap(A,B),C,D,E):-!,concatMap(A,B,C,D,E).
hnf(iterate(A,B),C,D,E):-!,iterate(A,B,C,D,E).
hnf(repeat(A),B,C,D):-!,repeat(A,B,C,D).
hnf(replicate(A,B),C,D,E):-!,replicate(A,B,C,D,E).
hnf(take(A,B),C,D,E):-!,take(A,B,C,D,E).
hnf(drop(A,B),C,D,E):-!,drop(A,B,C,D,E).
hnf(splitAt(A,B),C,D,E):-!,splitAt(A,B,C,D,E).
hnf(takeWhile(A,B),C,D,E):-!,takeWhile(A,B,C,D,E).
hnf(dropWhile(A,B),C,D,E):-!,dropWhile(A,B,C,D,E).
hnf(span(A,B),C,D,E):-!,span(A,B,C,D,E).
hnf(break(A,B),C,D,E):-!,break(A,B,C,D,E).
hnf(lines(A),B,C,D):-!,lines(A,B,C,D).
hnf(unlines(A),B,C,D):-!,unlines(A,B,C,D).
hnf(reverse(A),B,C,D):-!,reverse(A,B,C,D).
hnf(enumFrom(A),B,C,D):-!,enumFrom(A,B,C,D).
hnf(enumFromThen(A,B),C,D,E):-!,enumFromThen(A,B,C,D,E).
hnf(enumFromTo(A,B),C,D,E):-!,enumFromTo(A,B,C,D,E).
hnf(enumFromThenTo(A,B,C),D,E,F):-!,enumFromThenTo(A,B,C,D,E,F).
hnf(&>(A,B),C,D,E):-!,&>(A,B,C,D,E).
hnf(failed,A,B,C):-!,failed(A,B,C).
hnf(maybe(A,B,C),D,E,F):-!,maybe(A,B,C,D,E,F).
hnf(either(A,B,C),D,E,F):-!,either(A,B,C,D,E,F).
hnf(putStr(A),B,C,D):-!,putStr(A,B,C,D).
hnf(putStrLn(A),B,C,D):-!,putStrLn(A,B,C,D).
hnf(getLine,A,B,C):-!,getLine(A,B,C).
hnf(print(A),B,C,D):-!,print(A,B,C,D).
hnf(doSolve(A),B,C,D):-!,doSolve(A,B,C,D).
hnf(inject(A,B,C),D,E,F):-!,inject(A,B,C,D,E,F).
hnf(all(A),B,C,D):-!,all(A,B,C,D).
hnf(all2(A),B,C,D):-!,all2(A,B,C,D).
hnf(once(A,B),C,D,E):-!,once(A,B,C,D,E).
hnf(one(A),B,C,D):-!,one(A,B,C,D).
hnf(condSearch(A,B),C,D,E):-!,condSearch(A,B,C,D,E).
hnf(best(A,B),C,D,E):-!,best(A,B,C,D,E).
hnf(bestHelp(A,B,C,D),E,F,G):-!,bestHelp(A,B,C,D,E,F,G).
hnf(evalB(A,B,C,D),E,F,G):-!,evalB(A,B,C,D,E,F,G).
hnf(evalA(A,B,C,D,E),F,G,H):-!,evalA(A,B,C,D,E,F,G,H).
hnf(constrain(A,B,C,D),E,F,G):-!,constrain(A,B,C,D,E,F,G).
hnf(dfs(A),B,C,D):-!,dfs(A,B,C,D).
hnf(browseList(A),B,C,D):-!,browseList(A,B,C,D).
hnf(unpack(A),B,C,D):-!,unpack(A,B,C,D).
hnf(prelude_lambda0_1663(A,B,C),D,E,F):-!,prelude_lambda0_1663(A,B,C,D,E,F).
hnf(prelude_lambda1_1664(A,B,C),D,E,F):-!,prelude_lambda1_1664(A,B,C,D,E,F).
hnf(prelude_lambda2_1665(A,B,C,D),E,F,G):-!,prelude_lambda2_1665(A,B,C,D,E,F,G).
hnf(takep_343(A,B),C,D,E):-!,takep_343(A,B,C,D,E).
hnf(dropp_350(A,B),C,D,E):-!,dropp_350(A,B,C,D,E).
hnf(splitAtp_357(A,B),C,D,E):-!,splitAtp_357(A,B,C,D,E).
hnf(prelude_lambda3_1666(A,B),C,D,E):-!,prelude_lambda3_1666(A,B,C,D,E).
hnf(prelude_lambda4_1667(A,B),C,D,E):-!,prelude_lambda4_1667(A,B,C,D,E).
hnf(splitline_381(A),B,C,D):-!,splitline_381(A,B,C,D).
hnf(prelude_lambda5_1668(A,B),C,D,E):-!,prelude_lambda5_1668(A,B,C,D,E).
hnf(prelude_lambda6_1669(A),B,C,D):-!,prelude_lambda6_1669(A,B,C,D).
hnf(prelude_lambda7_1670(A),B,C,D):-!,prelude_lambda7_1670(A,B,C,D).
hnf(prelude_lambda8_1671(A,B,C),D,E,F):-!,prelude_lambda8_1671(A,B,C,D,E,F).
hnf(p_399(A,B,C,D),E,F,G):-!,p_399(A,B,C,D,E,F,G).
hnf(getLineReturn_418(A,B),C,D,E):-!,getLineReturn_418(A,B,C,D,E).
hnf(prelude_lambda9_1672(A),B,C,D):-!,prelude_lambda9_1672(A,B,C,D).
hnf(prelude_lambda10_1673(A,B,C),D,E,F):-!,prelude_lambda10_1673(A,B,C,D,E,F).
hnf(evalall_428(A),B,C,D):-!,evalall_428(A,B,C,D).
hnf(evalall2_429(A),B,C,D):-!,evalall2_429(A,B,C,D).
hnf(evalall3_430(A,B),C,D,E):-!,evalall3_430(A,B,C,D,E).
hnf(evalResult_445(A),B,C,D):-!,evalResult_445(A,B,C,D).
hnf(prelude_lambda11_1674(A,B),C,D,E):-!,prelude_lambda11_1674(A,B,C,D,E).
hnf(prelude_lambda12_1675(A,B,C),D,E,F):-!,prelude_lambda12_1675(A,B,C,D,E,F).
hnf(prelude_lambda13_1676(A,B,C),D,E,F):-!,prelude_lambda13_1676(A,B,C,D,E,F).
hnf(evaldfs_510(A),B,C,D):-!,evaldfs_510(A,B,C,D).
hnf(eval2_511(A,B),C,D,E):-!,eval2_511(A,B,C,D,E).
hnf(fun_geq(A,B),C,D,E):-!,fun_geq(A,B,C,D,E).
hnf(fun_cip(A,B),C,D,E):-!,fun_cip(A,B,C,D,E).
hnf(fun_cip3(A,B,C),D,E,F):-!,fun_cip3(A,B,C,D,E,F).
hnf(fun_xor(A,B),C,D,E):-!,fun_xor(A,B,C,D,E).
hnf(A+B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_+'(F,H,C,I,E).
hnf(A-B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_-'(F,H,C,I,E).
hnf(A*B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_*'(F,H,C,I,E).
hnf(div(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),prim_div(F,H,C,I,E).
hnf(A mod B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),prim_mod(F,H,C,I,E).
hnf(A<B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_<'(F,H,C,I,E).
hnf(A>B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_>'(F,H,C,I,E).
hnf(<=(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_<='(F,H,C,I,E).
hnf(A>=B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_>='(F,H,C,I,E).
hnf(ord(A),B,C,D):-!,hnf(A,E,C,F),prim_ord(E,B,F,D).
hnf(chr(A),B,C,D):-!,hnf(A,E,C,F),prim_chr(E,B,F,D).
hnf(>>=(A,B),C,D,E):-!,hnf(A,F,D,G),'prim_>>='(F,B,C,G,E).
hnf(A>>B,C,D,E):-!,hnf(A,F,D,G),'prim_>>'(F,B,C,G,E).
hnf(putChar(A),B,C,D):-!,hnf(A,E,C,F),prim_putChar(E,B,F,D).
hnf(getChar,A,B,C):-!,prim_getChar(A,B,C).
hnf(return(A),B,C,D):-!,prim_return(A,B,C,D).
hnf(done,A,B,C):-!,prim_done(A,B,C).
hnf(readFile(A),B,C,D):-!,nf(A,E,C,F),seq(E,E,G,F,H),prim_readFile(E,B,H,D).
hnf('#readFileContents'(A),B,C,D):-!,'prim_#readFileContents'(A,B,C,D).
hnf(writeFile(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),prim_writeFile(F,B,C,I,E).
hnf(appendFile(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),prim_appendFile(F,B,C,I,E).
hnf('#writeFileContents'(A,B),C,D,E):-!,hnf(B,F,D,G),'prim_#writeFileContents'(A,F,C,G,E).
hnf(findall(A),B,C,D):-!,hnf(A,E,C,F),prim_findall(E,B,F,D).
hnf(findfirst(A),B,C,D):-!,hnf(A,E,C,F),prim_findfirst(E,B,F,D).
hnf(unsafePrint(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),prim_unsafePrint(F,B,C,I,E).
hnf(show(A),B,C,D):-!,nf(A,E,C,F),seq(E,E,G,F,H),prim_show(E,B,H,D).
hnf('Flat_readFlatCurry'(A),B,C,D):-!,nf(A,E,C,F),seq(E,E,G,F,H),prim_Flat_readFlatCurry(E,B,H,D).
hnf('FlatString_readFlatCurry'(A),B,C,D):-!,nf(A,E,C,F),seq(E,E,G,F,H),prim_FlatString_readFlatCurry(E,B,H,D).
hnf('System_getCPUTime',A,B,C):-!,prim_System_getCPUTime(A,B,C).
hnf('System_getElapsedTime',A,B,C):-!,prim_System_getElapsedTime(A,B,C).
hnf('System_getDate',A,B,C):-!,prim_System_getDate(A,B,C).
hnf('System_getEnviron'(A),B,C,D):-!,nf(A,E,C,F),seq(E,E,G,F,H),prim_System_getEnviron(E,B,H,D).
hnf('System_getHostname',A,B,C):-!,prim_System_getHostname(A,B,C).
hnf('System_getPID',A,B,C):-!,prim_System_getPID(A,B,C).
hnf('System_system'(A),B,C,D):-!,nf(A,E,C,F),seq(E,E,G,F,H),prim_System_system(E,B,H,D).
hnf('System_sleep'(A),B,C,D):-!,nf(A,E,C,F),seq(E,E,G,F,H),prim_System_sleep(E,B,H,D).
hnf('System_evalTime'(A),B,C,D):-!,prim_System_evalTime(A,B,C,D).
hnf('System_evalSpace'(A),B,C,D):-!,prim_System_evalSpace(A,B,C,D).
hnf('Term_encodeTerm'(A),B,C,D):-!,nf(A,E,C,F),seq(E,E,G,F,H),prim_Term_encodeTerm(E,B,H,D).
hnf('Term_decodeTerm'(A),B,C,D):-!,nf(A,E,C,F),seq(E,E,G,F,H),prim_Term_decodeTerm(E,B,H,D).
hnf('Ports_openPort'(A,B),C,D,E):-!,nf(A,F,D,G),nf(B,H,G,I),prim_Ports_openPort(F,H,C,I,E).
hnf('#basicserverloop'(A),B,C,D):-!,'prim_#basicserverloop'(A,B,C,D).
hnf('Ports_send'(A,B),C,D,E):-!,nf(A,F,D,G),hnf(B,H,G,I),prim_Ports_send(F,H,C,I,E).
hnf('Ports_openProcessPort'(A),B,C,D):-!,nf(A,E,C,F),seq(E,E,G,F,H),prim_Ports_openProcessPort(E,B,H,D).
hnf('Ports_timeoutOnStream'(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),prim_Ports_timeoutOnStream(F,B,C,I,E).
hnf('Ports_openPortOnSocket'(A),B,C,D):-!,nf(A,E,C,F),prim_Ports_openPortOnSocket(E,B,F,D).
hnf('Ports_connectPortAtSocket'(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),nf(B,J,I,K),seq(J,J,L,K,M),prim_Ports_connectPortAtSocket(F,J,C,M,E).
hnf('CLPR_+:'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR_+:'(F,H,C,I,E).
hnf('CLPR_-:'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR_-:'(F,H,C,I,E).
hnf('CLPR_*:'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR_*:'(F,H,C,I,E).
hnf('CLPR_/:'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR_/:'(F,H,C,I,E).
hnf('CLPR_<:'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR_<:'(F,H,C,I,E).
hnf('CLPR_>:'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR_>:'(F,H,C,I,E).
hnf('CLPR_<=:'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR_<=:'(F,H,C,I,E).
hnf('CLPR_>=:'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR_>=:'(F,H,C,I,E).
hnf('CLPR_i2f'(A),B,C,D):-!,hnf(A,E,C,F),prim_CLPR_i2f(E,B,F,D).
hnf('CLPFD_#+'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD_#+'(F,H,C,I,E).
hnf('CLPFD_#-'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD_#-'(F,H,C,I,E).
hnf('CLPFD_#*'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD_#*'(F,H,C,I,E).
hnf('CLPFD_#='(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD_#='(F,H,C,I,E).
hnf('CLPFD_#/='(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD_#/='(F,H,C,I,E).
hnf('CLPFD_#<'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD_#<'(F,H,C,I,E).
hnf('CLPFD_#>'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD_#>'(F,H,C,I,E).
hnf('CLPFD_#<='(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD_#<='(F,H,C,I,E).
hnf('CLPFD_#>='(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD_#>='(F,H,C,I,E).
hnf('CLPFD_domain'(A,B,C),D,E,F):-!,nf(A,G,E,H),hnf(B,I,H,J),hnf(C,K,J,L),prim_CLPFD_domain(G,I,K,D,L,F).
hnf('CLPFD_all_different'(A),B,C,D):-!,nf(A,E,C,F),prim_CLPFD_all_different(E,B,F,D).
hnf('CLPFD_labeling'(A),B,C,D):-!,nf(A,E,C,F),prim_CLPFD_labeling(E,B,F,D).
hnf(try(A),B,C,D):-!,write('*** '),write(try(A)),write(' currently not supported!'),nl.
hnf(comittedChoice(A),B,C,D):-!,write('*** '),write(comittedChoice(A)),write(' currently not supported!'),nl.
hnf(browse(A),B,C,D):-!,write('*** '),write(browse(A)),write(' currently not supported!'),nl.
hnf(tryone(A),B,C,D):-!,write('*** '),write(tryone(A)),write(' currently not supported!'),nl.
hnf(A=:=B,success,C,D):-!,eq(A,B,C,D).
hnf(A==B,C,D,E):-!,seq(A,B,C,D,E).
hnf(&(A,B),success,C,D):-!,hnf(A,E,C,F),hnf(B,G,C,H),waitconj(E,G,F,H,D).
hnf(apply(A,B),C,D,E):-!,hnf(A,F,D,G),apply(F,B,C,G,E).
hnf(guardedexpr(A,B),C,D,E):-!,hnf(A,F,D,G),F==success,hnf(B,C,G,E).
hnf(A,A,B,B).

:-block apply(-,?,?,?,?),apply(?,?,?,-,?).
apply(==,A,==(A),B,B).
apply(==(A),B,C,D,E):-hnf(A==B,C,D,E).
apply(=:=,A,=:=(A),B,B).
apply(=:=(A),B,C,D,E):-hnf(A=:=B,C,D,E).
apply('$comp',A,'$comp'(A),B,B).
apply('$comp'(A),B,'$comp'(A,B),C,C).
apply('$comp'(A,B),C,D,E,F):-hnf('$comp'(A,B,C),D,E,F).
apply(id,A,B,C,D):-hnf(id(A),B,C,D).
apply(const,A,const(A),B,B).
apply(const(A),B,C,D,E):-hnf(const(A,B),C,D,E).
apply(curry,A,curry(A),B,B).
apply(curry(A),B,curry(A,B),C,C).
apply(curry(A,B),C,D,E,F):-hnf(curry(A,B,C),D,E,F).
apply(uncurry,A,uncurry(A),B,B).
apply(uncurry(A),B,C,D,E):-hnf(uncurry(A,B),C,D,E).
apply(flip,A,flip(A),B,B).
apply(flip(A),B,flip(A,B),C,C).
apply(flip(A,B),C,D,E,F):-hnf(flip(A,B,C),D,E,F).
apply($,A,$(A),B,B).
apply($(A),B,C,D,E):-hnf($(A,B),C,D,E).
apply(&&,A,&&(A),B,B).
apply(&&(A),B,C,D,E):-hnf(&&(A,B),C,D,E).
apply('||',A,'||'(A),B,B).
apply('||'(A),B,C,D,E):-hnf('||'(A,B),C,D,E).
apply(not,A,B,C,D):-hnf(not(A),B,C,D).
apply(if_then_else,A,if_then_else(A),B,B).
apply(if_then_else(A),B,if_then_else(A,B),C,C).
apply(if_then_else(A,B),C,D,E,F):-hnf(if_then_else(A,B,C),D,E,F).
apply(/=,A,/=(A),B,B).
apply(/=(A),B,C,D,E):-hnf(/=(A,B),C,D,E).
apply(fst,A,B,C,D):-hnf(fst(A),B,C,D).
apply(snd,A,B,C,D):-hnf(snd(A),B,C,D).
apply(head,A,B,C,D):-hnf(head(A),B,C,D).
apply(tail,A,B,C,D):-hnf(tail(A),B,C,D).
apply(null,A,B,C,D):-hnf(null(A),B,C,D).
apply(++,A,++(A),B,B).
apply(++(A),B,C,D,E):-hnf(++(A,B),C,D,E).
apply(length,A,B,C,D):-hnf(length(A),B,C,D).
apply('!!',A,'!!'(A),B,B).
apply('!!'(A),B,C,D,E):-hnf('!!'(A,B),C,D,E).
apply(map,A,map(A),B,B).
apply(map(A),B,C,D,E):-hnf(map(A,B),C,D,E).
apply(foldl,A,foldl(A),B,B).
apply(foldl(A),B,foldl(A,B),C,C).
apply(foldl(A,B),C,D,E,F):-hnf(foldl(A,B,C),D,E,F).
apply(foldl1,A,foldl1(A),B,B).
apply(foldl1(A),B,C,D,E):-hnf(foldl1(A,B),C,D,E).
apply(foldr,A,foldr(A),B,B).
apply(foldr(A),B,foldr(A,B),C,C).
apply(foldr(A,B),C,D,E,F):-hnf(foldr(A,B,C),D,E,F).
apply(foldr1,A,foldr1(A),B,B).
apply(foldr1(A),B,C,D,E):-hnf(foldr1(A,B),C,D,E).
apply(filter,A,filter(A),B,B).
apply(filter(A),B,C,D,E):-hnf(filter(A,B),C,D,E).
apply(zip,A,zip(A),B,B).
apply(zip(A),B,C,D,E):-hnf(zip(A,B),C,D,E).
apply(zip3,A,zip3(A),B,B).
apply(zip3(A),B,zip3(A,B),C,C).
apply(zip3(A,B),C,D,E,F):-hnf(zip3(A,B,C),D,E,F).
apply(unzip,A,B,C,D):-hnf(unzip(A),B,C,D).
apply(unzip3,A,B,C,D):-hnf(unzip3(A),B,C,D).
apply(concat,A,B,C,D):-hnf(concat(A),B,C,D).
apply(concatMap,A,concatMap(A),B,B).
apply(concatMap(A),B,C,D,E):-hnf(concatMap(A,B),C,D,E).
apply(iterate,A,iterate(A),B,B).
apply(iterate(A),B,C,D,E):-hnf(iterate(A,B),C,D,E).
apply(repeat,A,B,C,D):-hnf(repeat(A),B,C,D).
apply(replicate,A,replicate(A),B,B).
apply(replicate(A),B,C,D,E):-hnf(replicate(A,B),C,D,E).
apply(take,A,take(A),B,B).
apply(take(A),B,C,D,E):-hnf(take(A,B),C,D,E).
apply(drop,A,drop(A),B,B).
apply(drop(A),B,C,D,E):-hnf(drop(A,B),C,D,E).
apply(splitAt,A,splitAt(A),B,B).
apply(splitAt(A),B,C,D,E):-hnf(splitAt(A,B),C,D,E).
apply(takeWhile,A,takeWhile(A),B,B).
apply(takeWhile(A),B,C,D,E):-hnf(takeWhile(A,B),C,D,E).
apply(dropWhile,A,dropWhile(A),B,B).
apply(dropWhile(A),B,C,D,E):-hnf(dropWhile(A,B),C,D,E).
apply(span,A,span(A),B,B).
apply(span(A),B,C,D,E):-hnf(span(A,B),C,D,E).
apply(break,A,break(A),B,B).
apply(break(A),B,C,D,E):-hnf(break(A,B),C,D,E).
apply(lines,A,B,C,D):-hnf(lines(A),B,C,D).
apply(unlines,A,B,C,D):-hnf(unlines(A),B,C,D).
apply(reverse,A,B,C,D):-hnf(reverse(A),B,C,D).
apply(enumFrom,A,B,C,D):-hnf(enumFrom(A),B,C,D).
apply(enumFromThen,A,enumFromThen(A),B,B).
apply(enumFromThen(A),B,C,D,E):-hnf(enumFromThen(A,B),C,D,E).
apply(enumFromTo,A,enumFromTo(A),B,B).
apply(enumFromTo(A),B,C,D,E):-hnf(enumFromTo(A,B),C,D,E).
apply(enumFromThenTo,A,enumFromThenTo(A),B,B).
apply(enumFromThenTo(A),B,enumFromThenTo(A,B),C,C).
apply(enumFromThenTo(A,B),C,D,E,F):-hnf(enumFromThenTo(A,B,C),D,E,F).
apply(&>,A,&>(A),B,B).
apply(&>(A),B,C,D,E):-hnf(&>(A,B),C,D,E).
apply(maybe,A,maybe(A),B,B).
apply(maybe(A),B,maybe(A,B),C,C).
apply(maybe(A,B),C,D,E,F):-hnf(maybe(A,B,C),D,E,F).
apply(either,A,either(A),B,B).
apply(either(A),B,either(A,B),C,C).
apply(either(A,B),C,D,E,F):-hnf(either(A,B,C),D,E,F).
apply(putStr,A,B,C,D):-hnf(putStr(A),B,C,D).
apply(putStrLn,A,B,C,D):-hnf(putStrLn(A),B,C,D).
apply(print,A,B,C,D):-hnf(print(A),B,C,D).
apply(doSolve,A,B,C,D):-hnf(doSolve(A),B,C,D).
apply(inject,A,inject(A),B,B).
apply(inject(A),B,inject(A,B),C,C).
apply(inject(A,B),C,D,E,F):-hnf(inject(A,B,C),D,E,F).
apply(all,A,B,C,D):-hnf(all(A),B,C,D).
apply(all2,A,B,C,D):-hnf(all2(A),B,C,D).
apply(once,A,once(A),B,B).
apply(once(A),B,C,D,E):-hnf(once(A,B),C,D,E).
apply(one,A,B,C,D):-hnf(one(A),B,C,D).
apply(condSearch,A,condSearch(A),B,B).
apply(condSearch(A),B,C,D,E):-hnf(condSearch(A,B),C,D,E).
apply(best,A,best(A),B,B).
apply(best(A),B,C,D,E):-hnf(best(A,B),C,D,E).
apply(bestHelp,A,bestHelp(A),B,B).
apply(bestHelp(A),B,bestHelp(A,B),C,C).
apply(bestHelp(A,B),C,bestHelp(A,B,C),D,D).
apply(bestHelp(A,B,C),D,E,F,G):-hnf(bestHelp(A,B,C,D),E,F,G).
apply(evalB,A,evalB(A),B,B).
apply(evalB(A),B,evalB(A,B),C,C).
apply(evalB(A,B),C,evalB(A,B,C),D,D).
apply(evalB(A,B,C),D,E,F,G):-hnf(evalB(A,B,C,D),E,F,G).
apply(evalA,A,evalA(A),B,B).
apply(evalA(A),B,evalA(A,B),C,C).
apply(evalA(A,B),C,evalA(A,B,C),D,D).
apply(evalA(A,B,C),D,evalA(A,B,C,D),E,E).
apply(evalA(A,B,C,D),E,F,G,H):-hnf(evalA(A,B,C,D,E),F,G,H).
apply(constrain,A,constrain(A),B,B).
apply(constrain(A),B,constrain(A,B),C,C).
apply(constrain(A,B),C,constrain(A,B,C),D,D).
apply(constrain(A,B,C),D,E,F,G):-hnf(constrain(A,B,C,D),E,F,G).
apply(dfs,A,B,C,D):-hnf(dfs(A),B,C,D).
apply(browseList,A,B,C,D):-hnf(browseList(A),B,C,D).
apply(unpack,A,B,C,D):-hnf(unpack(A),B,C,D).
apply(prelude_lambda0_1663,A,prelude_lambda0_1663(A),B,B).
apply(prelude_lambda0_1663(A),B,prelude_lambda0_1663(A,B),C,C).
apply(prelude_lambda0_1663(A,B),C,D,E,F):-hnf(prelude_lambda0_1663(A,B,C),D,E,F).
apply(prelude_lambda1_1664,A,prelude_lambda1_1664(A),B,B).
apply(prelude_lambda1_1664(A),B,prelude_lambda1_1664(A,B),C,C).
apply(prelude_lambda1_1664(A,B),C,D,E,F):-hnf(prelude_lambda1_1664(A,B,C),D,E,F).
apply(prelude_lambda2_1665,A,prelude_lambda2_1665(A),B,B).
apply(prelude_lambda2_1665(A),B,prelude_lambda2_1665(A,B),C,C).
apply(prelude_lambda2_1665(A,B),C,prelude_lambda2_1665(A,B,C),D,D).
apply(prelude_lambda2_1665(A,B,C),D,E,F,G):-hnf(prelude_lambda2_1665(A,B,C,D),E,F,G).
apply(takep_343,A,takep_343(A),B,B).
apply(takep_343(A),B,C,D,E):-hnf(takep_343(A,B),C,D,E).
apply(dropp_350,A,dropp_350(A),B,B).
apply(dropp_350(A),B,C,D,E):-hnf(dropp_350(A,B),C,D,E).
apply(splitAtp_357,A,splitAtp_357(A),B,B).
apply(splitAtp_357(A),B,C,D,E):-hnf(splitAtp_357(A,B),C,D,E).
apply(prelude_lambda3_1666,A,prelude_lambda3_1666(A),B,B).
apply(prelude_lambda3_1666(A),B,C,D,E):-hnf(prelude_lambda3_1666(A,B),C,D,E).
apply(prelude_lambda4_1667,A,prelude_lambda4_1667(A),B,B).
apply(prelude_lambda4_1667(A),B,C,D,E):-hnf(prelude_lambda4_1667(A,B),C,D,E).
apply(splitline_381,A,B,C,D):-hnf(splitline_381(A),B,C,D).
apply(prelude_lambda5_1668,A,prelude_lambda5_1668(A),B,B).
apply(prelude_lambda5_1668(A),B,C,D,E):-hnf(prelude_lambda5_1668(A,B),C,D,E).
apply(prelude_lambda6_1669,A,B,C,D):-hnf(prelude_lambda6_1669(A),B,C,D).
apply(prelude_lambda7_1670,A,B,C,D):-hnf(prelude_lambda7_1670(A),B,C,D).
apply(prelude_lambda8_1671,A,prelude_lambda8_1671(A),B,B).
apply(prelude_lambda8_1671(A),B,prelude_lambda8_1671(A,B),C,C).
apply(prelude_lambda8_1671(A,B),C,D,E,F):-hnf(prelude_lambda8_1671(A,B,C),D,E,F).
apply(p_399,A,p_399(A),B,B).
apply(p_399(A),B,p_399(A,B),C,C).
apply(p_399(A,B),C,p_399(A,B,C),D,D).
apply(p_399(A,B,C),D,E,F,G):-hnf(p_399(A,B,C,D),E,F,G).
apply(getLineReturn_418,A,getLineReturn_418(A),B,B).
apply(getLineReturn_418(A),B,C,D,E):-hnf(getLineReturn_418(A,B),C,D,E).
apply(prelude_lambda9_1672,A,B,C,D):-hnf(prelude_lambda9_1672(A),B,C,D).
apply(prelude_lambda10_1673,A,prelude_lambda10_1673(A),B,B).
apply(prelude_lambda10_1673(A),B,prelude_lambda10_1673(A,B),C,C).
apply(prelude_lambda10_1673(A,B),C,D,E,F):-hnf(prelude_lambda10_1673(A,B,C),D,E,F).
apply(evalall_428,A,B,C,D):-hnf(evalall_428(A),B,C,D).
apply(evalall2_429,A,B,C,D):-hnf(evalall2_429(A),B,C,D).
apply(evalall3_430,A,evalall3_430(A),B,B).
apply(evalall3_430(A),B,C,D,E):-hnf(evalall3_430(A,B),C,D,E).
apply(evalResult_445,A,B,C,D):-hnf(evalResult_445(A),B,C,D).
apply(prelude_lambda11_1674,A,prelude_lambda11_1674(A),B,B).
apply(prelude_lambda11_1674(A),B,C,D,E):-hnf(prelude_lambda11_1674(A,B),C,D,E).
apply(prelude_lambda12_1675,A,prelude_lambda12_1675(A),B,B).
apply(prelude_lambda12_1675(A),B,prelude_lambda12_1675(A,B),C,C).
apply(prelude_lambda12_1675(A,B),C,D,E,F):-hnf(prelude_lambda12_1675(A,B,C),D,E,F).
apply(prelude_lambda13_1676,A,prelude_lambda13_1676(A),B,B).
apply(prelude_lambda13_1676(A),B,prelude_lambda13_1676(A,B),C,C).
apply(prelude_lambda13_1676(A,B),C,D,E,F):-hnf(prelude_lambda13_1676(A,B,C),D,E,F).
apply(evaldfs_510,A,B,C,D):-hnf(evaldfs_510(A),B,C,D).
apply(eval2_511,A,eval2_511(A),B,B).
apply(eval2_511(A),B,C,D,E):-hnf(eval2_511(A,B),C,D,E).
apply(fun_geq,A,fun_geq(A),B,B).
apply(fun_geq(A),B,C,D,E):-hnf(fun_geq(A,B),C,D,E).
apply(fun_cip,A,fun_cip(A),B,B).
apply(fun_cip(A),B,C,D,E):-hnf(fun_cip(A,B),C,D,E).
apply(fun_cip3,A,fun_cip3(A),B,B).
apply(fun_cip3(A),B,fun_cip3(A,B),C,C).
apply(fun_cip3(A,B),C,D,E,F):-hnf(fun_cip3(A,B,C),D,E,F).
apply(fun_xor,A,fun_xor(A),B,B).
apply(fun_xor(A),B,C,D,E):-hnf(fun_xor(A,B),C,D,E).
apply(=:=,A,=:=(A),B,B).
apply(=:=(A),B,C,D,E):-hnf(A=:=B,C,D,E).
apply(==,A,==(A),B,B).
apply(==(A),B,C,D,E):-hnf(A==B,C,D,E).
apply(&,A,&(A),B,B).
apply(&(A),B,C,D,E):-hnf(&(A,B),C,D,E).
apply(+,A,+(A),B,B).
apply(+(A),B,C,D,E):-hnf(A+B,C,D,E).
apply(-,A,-(A),B,B).
apply(-(A),B,C,D,E):-hnf(A-B,C,D,E).
apply(*,A,*(A),B,B).
apply(*(A),B,C,D,E):-hnf(A*B,C,D,E).
apply(div,A,div(A),B,B).
apply(div(A),B,C,D,E):-hnf(div(A,B),C,D,E).
apply(mod,A,mod(A),B,B).
apply(mod(A),B,C,D,E):-hnf(A mod B,C,D,E).
apply(<,A,<(A),B,B).
apply(<(A),B,C,D,E):-hnf(A<B,C,D,E).
apply(>,A,>(A),B,B).
apply(>(A),B,C,D,E):-hnf(A>B,C,D,E).
apply(<=,A,<=(A),B,B).
apply(<=(A),B,C,D,E):-hnf(<=(A,B),C,D,E).
apply(>=,A,>=(A),B,B).
apply(>=(A),B,C,D,E):-hnf(A>=B,C,D,E).
apply(ord,A,B,C,D):-hnf(ord(A),B,C,D).
apply(chr,A,B,C,D):-hnf(chr(A),B,C,D).
apply(>>=,A,>>=(A),B,B).
apply(>>=(A),B,C,D,E):-hnf(>>=(A,B),C,D,E).
apply(>>,A,>>(A),B,B).
apply(>>(A),B,C,D,E):-hnf(A>>B,C,D,E).
apply(putChar,A,B,C,D):-hnf(putChar(A),B,C,D).
apply(return,A,B,C,D):-hnf(return(A),B,C,D).
apply(readFile,A,B,C,D):-hnf(readFile(A),B,C,D).
apply('#readFileContents',A,B,C,D):-hnf('#readFileContents'(A),B,C,D).
apply(writeFile,A,writeFile(A),B,B).
apply(writeFile(A),B,C,D,E):-hnf(writeFile(A,B),C,D,E).
apply(appendFile,A,appendFile(A),B,B).
apply(appendFile(A),B,C,D,E):-hnf(appendFile(A,B),C,D,E).
apply('#writeFileContents',A,'#writeFileContents'(A),B,B).
apply('#writeFileContents'(A),B,C,D,E):-hnf('#writeFileContents'(A,B),C,D,E).
apply(findall,A,B,C,D):-hnf(findall(A),B,C,D).
apply(findfirst,A,B,C,D):-hnf(findfirst(A),B,C,D).
apply(unsafePrint,A,unsafePrint(A),B,B).
apply(unsafePrint(A),B,C,D,E):-hnf(unsafePrint(A,B),C,D,E).
apply(show,A,B,C,D):-hnf(show(A),B,C,D).
apply('Flat_readFlatCurry',A,B,C,D):-hnf('Flat_readFlatCurry'(A),B,C,D).
apply('FlatString_readFlatCurry',A,B,C,D):-hnf('FlatString_readFlatCurry'(A),B,C,D).
apply('System_getEnviron',A,B,C,D):-hnf('System_getEnviron'(A),B,C,D).
apply('System_system',A,B,C,D):-hnf('System_system'(A),B,C,D).
apply('System_sleep',A,B,C,D):-hnf('System_sleep'(A),B,C,D).
apply('System_evalTime',A,B,C,D):-hnf('System_evalTime'(A),B,C,D).
apply('System_evalSpace',A,B,C,D):-hnf('System_evalSpace'(A),B,C,D).
apply('Term_encodeTerm',A,B,C,D):-hnf('Term_encodeTerm'(A),B,C,D).
apply('Term_decodeTerm',A,B,C,D):-hnf('Term_decodeTerm'(A),B,C,D).
apply('Ports_openPort',A,'Ports_openPort'(A),B,B).
apply('Ports_openPort'(A),B,C,D,E):-hnf('Ports_openPort'(A,B),C,D,E).
apply('#basicserverloop',A,B,C,D):-hnf('#basicserverloop'(A),B,C,D).
apply('Ports_send',A,'Ports_send'(A),B,B).
apply('Ports_send'(A),B,C,D,E):-hnf('Ports_send'(A,B),C,D,E).
apply('Ports_openProcessPort',A,B,C,D):-hnf('Ports_openProcessPort'(A),B,C,D).
apply('Ports_timeoutOnStream',A,'Ports_timeoutOnStream'(A),B,B).
apply('Ports_timeoutOnStream'(A),B,C,D,E):-hnf('Ports_timeoutOnStream'(A,B),C,D,E).
apply('Ports_openPortOnSocket',A,B,C,D):-hnf('Ports_openPortOnSocket'(A),B,C,D).
apply('Ports_connectPortAtSocket',A,'Ports_connectPortAtSocket'(A),B,B).
apply('Ports_connectPortAtSocket'(A),B,C,D,E):-hnf('Ports_connectPortAtSocket'(A,B),C,D,E).
apply('CLPR_+:',A,'CLPR_+:'(A),B,B).
apply('CLPR_+:'(A),B,C,D,E):-hnf('CLPR_+:'(A,B),C,D,E).
apply('CLPR_-:',A,'CLPR_-:'(A),B,B).
apply('CLPR_-:'(A),B,C,D,E):-hnf('CLPR_-:'(A,B),C,D,E).
apply('CLPR_*:',A,'CLPR_*:'(A),B,B).
apply('CLPR_*:'(A),B,C,D,E):-hnf('CLPR_*:'(A,B),C,D,E).
apply('CLPR_/:',A,'CLPR_/:'(A),B,B).
apply('CLPR_/:'(A),B,C,D,E):-hnf('CLPR_/:'(A,B),C,D,E).
apply('CLPR_<:',A,'CLPR_<:'(A),B,B).
apply('CLPR_<:'(A),B,C,D,E):-hnf('CLPR_<:'(A,B),C,D,E).
apply('CLPR_>:',A,'CLPR_>:'(A),B,B).
apply('CLPR_>:'(A),B,C,D,E):-hnf('CLPR_>:'(A,B),C,D,E).
apply('CLPR_<=:',A,'CLPR_<=:'(A),B,B).
apply('CLPR_<=:'(A),B,C,D,E):-hnf('CLPR_<=:'(A,B),C,D,E).
apply('CLPR_>=:',A,'CLPR_>=:'(A),B,B).
apply('CLPR_>=:'(A),B,C,D,E):-hnf('CLPR_>=:'(A,B),C,D,E).
apply('CLPR_i2f',A,B,C,D):-hnf('CLPR_i2f'(A),B,C,D).
apply('CLPFD_#+',A,'CLPFD_#+'(A),B,B).
apply('CLPFD_#+'(A),B,C,D,E):-hnf('CLPFD_#+'(A,B),C,D,E).
apply('CLPFD_#-',A,'CLPFD_#-'(A),B,B).
apply('CLPFD_#-'(A),B,C,D,E):-hnf('CLPFD_#-'(A,B),C,D,E).
apply('CLPFD_#*',A,'CLPFD_#*'(A),B,B).
apply('CLPFD_#*'(A),B,C,D,E):-hnf('CLPFD_#*'(A,B),C,D,E).
apply('CLPFD_#=',A,'CLPFD_#='(A),B,B).
apply('CLPFD_#='(A),B,C,D,E):-hnf('CLPFD_#='(A,B),C,D,E).
apply('CLPFD_#/=',A,'CLPFD_#/='(A),B,B).
apply('CLPFD_#/='(A),B,C,D,E):-hnf('CLPFD_#/='(A,B),C,D,E).
apply('CLPFD_#<',A,'CLPFD_#<'(A),B,B).
apply('CLPFD_#<'(A),B,C,D,E):-hnf('CLPFD_#<'(A,B),C,D,E).
apply('CLPFD_#>',A,'CLPFD_#>'(A),B,B).
apply('CLPFD_#>'(A),B,C,D,E):-hnf('CLPFD_#>'(A,B),C,D,E).
apply('CLPFD_#<=',A,'CLPFD_#<='(A),B,B).
apply('CLPFD_#<='(A),B,C,D,E):-hnf('CLPFD_#<='(A,B),C,D,E).
apply('CLPFD_#>=',A,'CLPFD_#>='(A),B,B).
apply('CLPFD_#>='(A),B,C,D,E):-hnf('CLPFD_#>='(A,B),C,D,E).
apply('CLPFD_domain',A,'CLPFD_domain'(A),B,B).
apply('CLPFD_domain'(A),B,'CLPFD_domain'(A,B),C,C).
apply('CLPFD_domain'(A,B),C,D,E,F):-hnf('CLPFD_domain'(A,B,C),D,E,F).
apply('CLPFD_all_different',A,B,C,D):-hnf('CLPFD_all_different'(A),B,C,D).
apply('CLPFD_labeling',A,B,C,D):-hnf('CLPFD_labeling'(A),B,C,D).
apply('(,)',A,'(,)'(A),B,B).
apply('(,)'(A),B,C,D,E):-hnf('(,)'(A,B),C,D,E).
apply('.',A,'.'(A),B,B).
apply('.'(A),B,C,D,E):-hnf([A|B],C,D,E).
apply('$io',A,B,C,D):-hnf('$io'(A),B,C,D).
apply('Just',A,B,C,D):-hnf('Just'(A),B,C,D).
apply('Left',A,B,C,D):-hnf('Left'(A),B,C,D).
apply('Right',A,B,C,D):-hnf('Right'(A),B,C,D).
apply(fun_succ,A,B,C,D):-hnf(fun_succ(A),B,C,D).
apply('$stream',A,B,C,D):-hnf('$stream'(A),B,C,D).
apply('(,)',A,'(,)'(A),B,B).
apply('(,)'(A),B,C,D,E):-hnf('(,)'(A,B),C,D,E).
apply('(,,)',A,'(,,)'(A),B,B).
apply('(,,)'(A),B,'(,,)'(A,B),C,C).
apply('(,,)'(A,B),C,D,E,F):-hnf('(,,)'(A,B,C),D,E,F).
apply('(,,,)',A,'(,,,)'(A),B,B).
apply('(,,,)'(A),B,'(,,,)'(A,B),C,C).
apply('(,,,)'(A,B),C,'(,,,)'(A,B,C),D,D).
apply('(,,,)'(A,B,C),D,E,F,G):-hnf('(,,,)'(A,B,C,D),E,F,G).
apply('(,,,,)',A,'(,,,,)'(A),B,B).
apply('(,,,,)'(A),B,'(,,,,)'(A,B),C,C).
apply('(,,,,)'(A,B),C,'(,,,,)'(A,B,C),D,D).
apply('(,,,,)'(A,B,C),D,'(,,,,)'(A,B,C,D),E,E).
apply('(,,,,)'(A,B,C,D),E,F,G,H):-hnf('(,,,,)'(A,B,C,D,E),F,G,H).

:- block eq(?,?,-,?).
eq(A,B,C,D):-hnf(A,E,C,F),hnf(B,G,F,H),eq_hnf(E,G,H,D).

:- block eq_hnf(?,?,-,?).
eq_hnf(A,B,C,D):-var(A),!,bind_trynf(A,B,C,D).
eq_hnf(A,B,C,D):-var(B),!,bind_trynf(B,A,C,D).
eq_hnf('True','True',A,A):-!.
eq_hnf('False','False',A,A):-!.
eq_hnf('(,)'(A,B),'(,)'(C,D),E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
eq_hnf([],[],A,A):-!.
eq_hnf([A|B],[C|D],E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
eq_hnf('$io'(A),'$io'(B),C,D):-!,hnf(A=:=B,E,C,D).
eq_hnf('()','()',A,A):-!.
eq_hnf(success,success,A,A):-!.
eq_hnf('Nothing','Nothing',A,A):-!.
eq_hnf('Just'(A),'Just'(B),C,D):-!,hnf(A=:=B,E,C,D).
eq_hnf('Left'(A),'Left'(B),C,D):-!,hnf(A=:=B,E,C,D).
eq_hnf('Right'(A),'Right'(B),C,D):-!,hnf(A=:=B,E,C,D).
eq_hnf(fun_zero,fun_zero,A,A):-!.
eq_hnf(fun_succ(A),fun_succ(B),C,D):-!,hnf(A=:=B,E,C,D).
eq_hnf(fun_a,fun_a,A,A):-!.
eq_hnf(fun_b,fun_b,A,A):-!.
eq_hnf(fun_c,fun_c,A,A):-!.
eq_hnf('$stream'(A),'$stream'(B),C,D):-!,hnf(A=:=B,E,C,D).
eq_hnf('()','()',A,A):-!.
eq_hnf('(,)'(A,B),'(,)'(C,D),E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
eq_hnf('(,,)'(A,B,C),'(,,)'(D,E,F),G,H):-!,hnf(&(A=:=D,&(B=:=E,C=:=F)),I,G,H).
eq_hnf('(,,,)'(A,B,C,D),'(,,,)'(E,F,G,H),I,J):-!,hnf(&(A=:=E,&(B=:=F,&(C=:=G,D=:=H))),K,I,J).
eq_hnf('(,,,,)'(A,B,C,D,E),'(,,,,)'(F,G,H,I,J),K,L):-!,hnf(&(A=:=F,&(B=:=G,&(C=:=H,&(D=:=I,E=:=J)))),M,K,L).
eq_hnf(A,A,B,B):-integer(A),!.
eq_hnf(A,B,C,C):-float(A),!,{A=B}.
eq_hnf(A,B,C,D):-functor(A,E,F),functor(B,G,H),E==G,F==H,gen_eq_hnf_body(1,F,A,B,I),hnf(I,J,C,D).

gen_eq_hnf_body(A,B,C,D,success):-A>B,!.
gen_eq_hnf_body(A,B,C,D,E=:=F):-A=B,!,arg(A,C,E),arg(A,D,F).
gen_eq_hnf_body(A,B,C,D,&(E=:=F,G)):-arg(A,C,E),arg(A,D,F),H is A+1,gen_eq_hnf_body(H,B,C,D,G).

bind_trynf(A,B,C,D):-nf(B,E,C,F),(nonvar(F)->bind_direct(A,E,F,D);bind(A,B,C,D)).
bind_direct(A,B,C,C):-var(B),!,A=B.
bind_direct(A,B,C,C):-occurs_not(A,B),A=B.

bind(A,B,C,C):-var(B),!,A=B.
bind(A,'True',B,B):-!,A='True'.
bind(A,'False',B,B):-!,A='False'.
bind(A,'(,)'(B,C),D,E):-!,occurs_not(A,B),occurs_not(A,C),A='(,)'(F,G),hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,[],B,B):-!,A=[].
bind(A,[B|C],D,E):-!,occurs_not(A,B),occurs_not(A,C),A=[F|G],hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'$io'(B),C,D):-!,occurs_not(A,B),A='$io'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'()',B,B):-!,A='()'.
bind(A,success,B,B):-!,A=success.
bind(A,'Nothing',B,B):-!,A='Nothing'.
bind(A,'Just'(B),C,D):-!,occurs_not(A,B),A='Just'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'Left'(B),C,D):-!,occurs_not(A,B),A='Left'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'Right'(B),C,D):-!,occurs_not(A,B),A='Right'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,fun_zero,B,B):-!,A=fun_zero.
bind(A,fun_succ(B),C,D):-!,occurs_not(A,B),A=fun_succ(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,fun_a,B,B):-!,A=fun_a.
bind(A,fun_b,B,B):-!,A=fun_b.
bind(A,fun_c,B,B):-!,A=fun_c.
bind(A,'$stream'(B),C,D):-!,occurs_not(A,B),A='$stream'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'()',B,B):-!,A='()'.
bind(A,'(,)'(B,C),D,E):-!,occurs_not(A,B),occurs_not(A,C),A='(,)'(F,G),hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'(,,)'(B,C,D),E,F):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),A='(,,)'(G,H,I),hnf(B,J,E,K),bind(G,J,K,L),hnf(C,M,L,N),bind(H,M,N,O),hnf(D,P,O,Q),bind(I,P,Q,F).
bind(A,'(,,,)'(B,C,D,E),F,G):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),A='(,,,)'(H,I,J,K),hnf(B,L,F,M),bind(H,L,M,N),hnf(C,O,N,P),bind(I,O,P,Q),hnf(D,R,Q,S),bind(J,R,S,T),hnf(E,U,T,V),bind(K,U,V,G).
bind(A,'(,,,,)'(B,C,D,E,F),G,H):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),A='(,,,,)'(I,J,K,L,M),hnf(B,N,G,O),bind(I,N,O,P),hnf(C,Q,P,R),bind(J,Q,R,S),hnf(D,T,S,U),bind(K,T,U,V),hnf(E,W,V,X),bind(L,W,X,Y),hnf(F,Z,Y,A1),bind(M,Z,A1,H).
bind(A,B,C,C):-integer(B),!,A=B.
bind(A,B,C,C):-float(B),!,{A=B}.
bind(A,B,C,D):-functor(B,E,F),occurs_not_args(1,F,A,B),functor(A,E,F),bind_args(1,F,A,B,C,D).

occurs_not_args(A,B,C,D):-A>B,!.
occurs_not_args(A,B,C,D):-arg(A,D,E),occurs_not(C,E),F is A+1,occurs_not_args(F,B,C,D).

bind_args(A,B,C,D,E,E):-A>B,!.
bind_args(A,B,C,D,E,F):-arg(A,C,G),arg(A,D,H),hnf(H,I,E,J),bind(G,I,J,K),L is A+1,bind_args(L,B,C,D,K,F).

occurs_not(A,B):-var(B),!,A\==B.
occurs_not(A,'True'):-!.
occurs_not(A,'False'):-!.
occurs_not(A,'(,)'(B,C)):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,[]):-!.
occurs_not(A,[B|C]):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'$io'(B)):-!,occurs_not(A,B).
occurs_not(A,'()'):-!.
occurs_not(A,success):-!.
occurs_not(A,'Nothing'):-!.
occurs_not(A,'Just'(B)):-!,occurs_not(A,B).
occurs_not(A,'Left'(B)):-!,occurs_not(A,B).
occurs_not(A,'Right'(B)):-!,occurs_not(A,B).
occurs_not(A,fun_zero):-!.
occurs_not(A,fun_succ(B)):-!,occurs_not(A,B).
occurs_not(A,fun_a):-!.
occurs_not(A,fun_b):-!.
occurs_not(A,fun_c):-!.
occurs_not(A,'$stream'(B)):-!,occurs_not(A,B).
occurs_not(A,'()'):-!.
occurs_not(A,'(,)'(B,C)):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'(,,)'(B,C,D)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D).
occurs_not(A,'(,,,)'(B,C,D,E)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E).
occurs_not(A,'(,,,,)'(B,C,D,E,F)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F).
occurs_not(_,_).

:- block seq(?,?,?,-,?).
seq(A,B,C,D,E):-hnf(A,F,D,G),hnf(B,H,G,I),seq_hnf(F,H,C,I,E).

:- block seq_hnf(-,?,?,?,?), seq_hnf(?,-,?,?,?), seq_hnf(?,?,?,-,?).
seq_hnf('True','True',A,B,C):-!,hnf('True',A,B,C).
seq_hnf('False','False',A,B,C):-!,hnf('True',A,B,C).
seq_hnf('(,)'(A,B),'(,)'(C,D),E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
seq_hnf([],[],A,B,C):-!,hnf('True',A,B,C).
seq_hnf([A|B],[C|D],E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
seq_hnf('$io'(A),'$io'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
seq_hnf('()','()',A,B,C):-!,hnf('True',A,B,C).
seq_hnf(success,success,A,B,C):-!,hnf('True',A,B,C).
seq_hnf('Nothing','Nothing',A,B,C):-!,hnf('True',A,B,C).
seq_hnf('Just'(A),'Just'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
seq_hnf('Left'(A),'Left'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
seq_hnf('Right'(A),'Right'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
seq_hnf(fun_zero,fun_zero,A,B,C):-!,hnf('True',A,B,C).
seq_hnf(fun_succ(A),fun_succ(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
seq_hnf(fun_a,fun_a,A,B,C):-!,hnf('True',A,B,C).
seq_hnf(fun_b,fun_b,A,B,C):-!,hnf('True',A,B,C).
seq_hnf(fun_c,fun_c,A,B,C):-!,hnf('True',A,B,C).
seq_hnf('$stream'(A),'$stream'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
seq_hnf('()','()',A,B,C):-!,hnf('True',A,B,C).
seq_hnf('(,)'(A,B),'(,)'(C,D),E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
seq_hnf('(,,)'(A,B,C),'(,,)'(D,E,F),G,H,I):-!,hnf(&&(A==D,&&(B==E,&&(C==F,'True'))),G,H,I).
seq_hnf('(,,,)'(A,B,C,D),'(,,,)'(E,F,G,H),I,J,K):-!,hnf(&&(A==E,&&(B==F,&&(C==G,&&(D==H,'True')))),I,J,K).
seq_hnf('(,,,,)'(A,B,C,D,E),'(,,,,)'(F,G,H,I,J),K,L,M):-!,hnf(&&(A==F,&&(B==G,&&(C==H,&&(D==I,&&(E==J,'True'))))),K,L,M).
seq_hnf(A,B,C,D,D):-number(A),!,(A==B->C='True';C='False').
seq_hnf(A,B,C,D,E):-functor(A,F,G),functor(B,H,I),(F==H,G==I,gen_seq_hnf_body(1,G,A,B,J)->hnf(J,C,D,E);D=E,C='False').

gen_seq_hnf_body(A,B,C,D,'True'):-A>B,!.
gen_seq_hnf_body(A,B,C,D,&&(E==F,G)):-arg(A,C,E),arg(A,D,F),H is A+1,gen_seq_hnf_body(H,B,C,D,G).

:- block nf(?,?,-,?).
nf(A,B,C,D):-hnf(A,E,C,F),nf_hnf(E,B,F,D).

:- block nf_hnf(?,?,-,?).
nf_hnf(A,B,C,C):-var(A),!,B=A.
nf_hnf('True','True',A,A):-!.
nf_hnf('False','False',A,A):-!.
nf_hnf('(,)'(A,B),'(,)'(C,D),E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf([],[],A,A):-!.
nf_hnf([A|B],[C|D],E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('$io'(A),'$io'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('()','()',A,A):-!.
nf_hnf(success,success,A,A):-!.
nf_hnf('Nothing','Nothing',A,A):-!.
nf_hnf('Just'(A),'Just'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('Left'(A),'Left'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('Right'(A),'Right'(B),C,D):-!,nf(A,B,C,D).
nf_hnf(fun_zero,fun_zero,A,A):-!.
nf_hnf(fun_succ(A),fun_succ(B),C,D):-!,nf(A,B,C,D).
nf_hnf(fun_a,fun_a,A,A):-!.
nf_hnf(fun_b,fun_b,A,A):-!.
nf_hnf(fun_c,fun_c,A,A):-!.
nf_hnf('$stream'(A),'$stream'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('()','()',A,A):-!.
nf_hnf('(,)'(A,B),'(,)'(C,D),E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('(,,)'(A,B,C),'(,,)'(D,E,F),G,H):-!,nf(A,D,G,I),nf(B,E,I,J),nf(C,F,J,H).
nf_hnf('(,,,)'(A,B,C,D),'(,,,)'(E,F,G,H),I,J):-!,nf(A,E,I,K),nf(B,F,K,L),nf(C,G,L,M),nf(D,H,M,J).
nf_hnf('(,,,,)'(A,B,C,D,E),'(,,,,)'(F,G,H,I,J),K,L):-!,nf(A,F,K,M),nf(B,G,M,N),nf(C,H,N,O),nf(D,I,O,P),nf(E,J,P,L).
nf_hnf(A,A,B,B):-number(A),!.
nf_hnf(A,B,C,D):-functor(A,E,F),functor(B,E,F),nf_hnf_args(1,F,A,B,C,D).

nf_hnf_args(A,B,C,D,E,E):-A>B,!.
nf_hnf_args(A,B,C,D,E,F):-arg(A,C,G),arg(A,D,H),nf(G,H,E,I),J is A+1,nf_hnf_args(J,B,C,D,I,F).

propagateShare(A,A):-var(A),!.
propagateShare('True','True'):-!.
propagateShare('False','False'):-!.
propagateShare('(,)'(A,B),'(,)'(C,D)):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare([],[]):-!.
propagateShare([A|B],[C|D]):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('$io'(A),'$io'(B)):-!,propSharArg(A,B).
propagateShare('()','()'):-!.
propagateShare(success,success):-!.
propagateShare('Nothing','Nothing'):-!.
propagateShare('Just'(A),'Just'(B)):-!,propSharArg(A,B).
propagateShare('Left'(A),'Left'(B)):-!,propSharArg(A,B).
propagateShare('Right'(A),'Right'(B)):-!,propSharArg(A,B).
propagateShare(fun_zero,fun_zero):-!.
propagateShare(fun_succ(A),fun_succ(B)):-!,propSharArg(A,B).
propagateShare(fun_a,fun_a):-!.
propagateShare(fun_b,fun_b):-!.
propagateShare(fun_c,fun_c):-!.
propagateShare('()','()'):-!.
propagateShare('(,)'(A,B),'(,)'(C,D)):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('(,,)'(A,B,C),'(,,)'(D,E,F)):-!,propSharArg(A,D),propSharArg(B,E),propSharArg(C,F).
propagateShare('(,,,)'(A,B,C,D),'(,,,)'(E,F,G,H)):-!,propSharArg(A,E),propSharArg(B,F),propSharArg(C,G),propSharArg(D,H).
propagateShare('(,,,,)'(A,B,C,D,E),'(,,,,)'(F,G,H,I,J)):-!,propSharArg(A,F),propSharArg(B,G),propSharArg(C,H),propSharArg(D,I),propSharArg(E,J).
propagateShare('Ports_internalPort'(A,B,C),'Ports_internalPort'(A,B,C)):-!.
propagateShare('$stream'(A),'$stream'(A)):-!.
propagateShare(A,A):-number(A),!.
propagateShare(A,B):-functor(A,C,D),functor(B,C,D),propagateShare_args(1,D,A,B).

propagateShare_args(A,B,C,D):-A>B,!.
propagateShare_args(A,B,C,D):-arg(A,C,E),arg(A,D,F),propSharArg(E,F),G is A+1,propagateShare_args(G,B,C,D).

translate(:,'.').
translate('.','$comp').
translate('Int','Int').
translate('True','True').
translate('False','False').
translate('Bool','Bool').
translate([],[]).
translate('(,)','(,)').
translate('Success','Success').
translate(success,success).
translate('$io','$io').
translate('IO','IO').
translate('()','()').
translate('Ports_internalPort','Ports_internalPort').
translate('Port','Port').
translate('Maybe','Maybe').
translate('Nothing','Nothing').
translate('Just','Just').
translate('Either','Either').
translate('Left','Left').
translate('Right','Right').
translate(+,+).
translate(-,-).
translate(*,*).
translate(div,div).
translate(mod,mod).
translate(==,==).
translate(<,<).
translate(>,>).
translate(<=,<=).
translate(>=,>=).
translate(=:=,=:=).
translate(&,&).
translate(success,success).
translate(>>,>>).
translate(>>=,>>=).
translate(putChar,putChar).
translate(getChar,getChar).
translate(done,done).
translate(return,return).
translate(readFile,readFile).
translate(writeFile,writeFile).
translate(appendFile,appendFile).
translate(show,show).
translate(try,try).
translate(browse,browse).
translate(ord,ord).
translate(chr,chr).
translate(unsafePrint,unsafePrint).
translate('$comp','$comp').
translate(id,id).
translate(const,const).
translate(curry,curry).
translate(uncurry,uncurry).
translate(flip,flip).
translate($,$).
translate(&&,&&).
translate('||','||').
translate(not,not).
translate(otherwise,otherwise).
translate(if_then_else,if_then_else).
translate(/=,/=).
translate(fst,fst).
translate(snd,snd).
translate(head,head).
translate(tail,tail).
translate(null,null).
translate(++,++).
translate(length,length).
translate('!!','!!').
translate(map,map).
translate(foldl,foldl).
translate(foldl1,foldl1).
translate(foldr,foldr).
translate(foldr1,foldr1).
translate(filter,filter).
translate(zip,zip).
translate(zip3,zip3).
translate(unzip,unzip).
translate(unzip3,unzip3).
translate(concat,concat).
translate(concatMap,concatMap).
translate(iterate,iterate).
translate(repeat,repeat).
translate(replicate,replicate).
translate(take,take).
translate(drop,drop).
translate(splitAt,splitAt).
translate(takeWhile,takeWhile).
translate(dropWhile,dropWhile).
translate(span,span).
translate(break,break).
translate(lines,lines).
translate(unlines,unlines).
translate(reverse,reverse).
translate(enumFrom,enumFrom).
translate(enumFromThen,enumFromThen).
translate(enumFromTo,enumFromTo).
translate(enumFromThenTo,enumFromThenTo).
translate(&>,&>).
translate(failed,failed).
translate(maybe,maybe).
translate(either,either).
translate(putStr,putStr).
translate(putStrLn,putStrLn).
translate(getLine,getLine).
translate(print,print).
translate(doSolve,doSolve).
translate(inject,inject).
translate(all,all).
translate(all2,all2).
translate(once,once).
translate(tryone,tryone).
translate(one,one).
translate(condSearch,condSearch).
translate(best,best).
translate(bestHelp,bestHelp).
translate(evalB,evalB).
translate(evalA,evalA).
translate(constrain,constrain).
translate(findall,findall).
translate(findfirst,findfirst).
translate(dfs,dfs).
translate(browseList,browseList).
translate(unpack,unpack).
translate(natural,fun_natural).
translate(zero,fun_zero).
translate(succ,fun_succ).
translate(abc,fun_abc).
translate(a,fun_a).
translate(b,fun_b).
translate(c,fun_c).
translate(geq,fun_geq).
translate(cip,fun_cip).
translate(cip3,fun_cip3).
translate(xor,fun_xor).
functiontype(+,[tcons('Int',[]),tcons('Int',[]),tcons('Int',[])]).
functiontype(-,[tcons('Int',[]),tcons('Int',[]),tcons('Int',[])]).
functiontype(*,[tcons('Int',[]),tcons('Int',[]),tcons('Int',[])]).
functiontype(div,[tcons('Int',[]),tcons('Int',[]),tcons('Int',[])]).
functiontype(mod,[tcons('Int',[]),tcons('Int',[]),tcons('Int',[])]).
functiontype(==,[tvar(A),tvar(A),tcons('Bool',[])]).
functiontype(<,[tcons('Int',[]),tcons('Int',[]),tcons('Bool',[])]).
functiontype(>,[tcons('Int',[]),tcons('Int',[]),tcons('Bool',[])]).
functiontype(<=,[tcons('Int',[]),tcons('Int',[]),tcons('Bool',[])]).
functiontype(>=,[tcons('Int',[]),tcons('Int',[]),tcons('Bool',[])]).
functiontype(=:=,[tvar(A),tvar(A),tcons('Success',[])]).
functiontype(&,[tcons('Success',[]),tcons('Success',[]),tcons('Success',[])]).
functiontype(success,[tcons('Success',[])]).
functiontype(>>,[tcons('IO',[tvar(A)]),tcons('IO',[tvar(B)]),tcons('IO',[tvar(B)])]).
functiontype(>>=,[tcons('IO',[tvar(A)]),functype(tvar(A),tcons('IO',[tvar(B)])),tcons('IO',[tvar(B)])]).
functiontype(putChar,[tcons('Char',[]),tcons('IO',[tcons('()',[])])]).
functiontype(getChar,[tcons('IO',[tcons('Char',[])])]).
functiontype(done,[tcons('IO',[tcons('()',[])])]).
functiontype(return,[tvar(A),tcons('IO',[tvar(A)])]).
functiontype(readFile,[tcons([],[tcons('Char',[])]),tcons('IO',[tcons([],[tcons('Char',[])])])]).
functiontype(writeFile,[tcons([],[tcons('Char',[])]),tcons([],[tcons('Char',[])]),tcons('IO',[tcons('()',[])])]).
functiontype(appendFile,[tcons([],[tcons('Char',[])]),tcons([],[tcons('Char',[])]),tcons('IO',[tcons('()',[])])]).
functiontype(show,[tvar(A),tcons([],[tcons('Char',[])])]).
functiontype(try,[functype(tvar(A),tcons('Success',[])),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(browse,[functype(tvar(A),tcons('Success',[])),tcons('IO',[tcons('()',[])])]).
functiontype(ord,[tcons('Char',[]),tcons('Int',[])]).
functiontype(chr,[tcons('Int',[]),tcons('Char',[])]).
functiontype(unsafePrint,[tcons([],[tcons('Char',[])]),tvar(A),tvar(A)]).
functiontype('$comp',[functype(tvar(A),tvar(B)),functype(tvar(C),tvar(A)),tvar(C),tvar(B)]).
functiontype(id,[tvar(A),tvar(A)]).
functiontype(const,[tvar(A),tvar(B),tvar(A)]).
functiontype(curry,[functype(tcons('(,)',[tvar(A),tvar(B)]),tvar(C)),tvar(A),tvar(B),tvar(C)]).
functiontype(uncurry,[functype(tvar(A),functype(tvar(B),tvar(C))),tcons('(,)',[tvar(A),tvar(B)]),tvar(C)]).
functiontype(flip,[functype(tvar(A),functype(tvar(B),tvar(C))),tvar(B),tvar(A),tvar(C)]).
functiontype($,[functype(tvar(A),tvar(B)),tvar(A),tvar(B)]).
functiontype(&&,[tcons('Bool',[]),tcons('Bool',[]),tcons('Bool',[])]).
functiontype('||',[tcons('Bool',[]),tcons('Bool',[]),tcons('Bool',[])]).
functiontype(not,[tcons('Bool',[]),tcons('Bool',[])]).
functiontype(otherwise,[tcons('Bool',[])]).
functiontype(if_then_else,[tcons('Bool',[]),tvar(A),tvar(A),tvar(A)]).
functiontype(/=,[tvar(A),tvar(A),tcons('Bool',[])]).
functiontype(fst,[tcons('(,)',[tvar(A),tvar(B)]),tvar(A)]).
functiontype(snd,[tcons('(,)',[tvar(A),tvar(B)]),tvar(B)]).
functiontype(head,[tcons([],[tvar(A)]),tvar(A)]).
functiontype(tail,[tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(null,[tcons([],[tvar(A)]),tcons('Bool',[])]).
functiontype(++,[tcons([],[tvar(A)]),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(length,[tcons([],[tvar(A)]),tcons('Int',[])]).
functiontype('!!',[tcons([],[tvar(A)]),tcons('Int',[]),tvar(A)]).
functiontype(map,[functype(tvar(A),tvar(B)),tcons([],[tvar(A)]),tcons([],[tvar(B)])]).
functiontype(foldl,[functype(tvar(A),functype(tvar(B),tvar(A))),tvar(A),tcons([],[tvar(B)]),tvar(A)]).
functiontype(foldl1,[functype(tvar(A),functype(tvar(A),tvar(A))),tcons([],[tvar(A)]),tvar(A)]).
functiontype(foldr,[functype(tvar(A),functype(tvar(B),tvar(B))),tvar(B),tcons([],[tvar(A)]),tvar(B)]).
functiontype(foldr1,[functype(tvar(A),functype(tvar(A),tvar(A))),tcons([],[tvar(A)]),tvar(A)]).
functiontype(filter,[functype(tvar(A),tcons('Bool',[])),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(zip,[tcons([],[tvar(A)]),tcons([],[tvar(B)]),tcons([],[tcons('(,)',[tvar(A),tvar(B)])])]).
functiontype(zip3,[tcons([],[tvar(A)]),tcons([],[tvar(B)]),tcons([],[tvar(C)]),tcons([],[tcons('(,,)',[tvar(A),tvar(B),tvar(C)])])]).
functiontype(unzip,[tcons([],[tcons('(,)',[tvar(A),tvar(B)])]),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(B)])])]).
functiontype(unzip3,[tcons([],[tcons('(,,)',[tvar(A),tvar(B),tvar(C)])]),tcons('(,,)',[tcons([],[tvar(A)]),tcons([],[tvar(B)]),tcons([],[tvar(C)])])]).
functiontype(concat,[tcons([],[tcons([],[tvar(A)])]),tcons([],[tvar(A)])]).
functiontype(concatMap,[functype(tvar(A),tcons([],[tvar(B)])),tcons([],[tvar(A)]),tcons([],[tvar(B)])]).
functiontype(iterate,[functype(tvar(A),tvar(A)),tvar(A),tcons([],[tvar(A)])]).
functiontype(repeat,[tvar(A),tcons([],[tvar(A)])]).
functiontype(replicate,[tcons('Int',[]),tvar(A),tcons([],[tvar(A)])]).
functiontype(take,[tcons('Int',[]),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(drop,[tcons('Int',[]),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(splitAt,[tcons('Int',[]),tcons([],[tvar(A)]),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(A)])])]).
functiontype(takeWhile,[functype(tvar(A),tcons('Bool',[])),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(dropWhile,[functype(tvar(A),tcons('Bool',[])),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(span,[functype(tvar(A),tcons('Bool',[])),tcons([],[tvar(A)]),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(A)])])]).
functiontype(break,[functype(tvar(A),tcons('Bool',[])),tcons([],[tvar(A)]),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(A)])])]).
functiontype(lines,[tcons([],[tcons('Char',[])]),tcons([],[tcons([],[tcons('Char',[])])])]).
functiontype(unlines,[tcons([],[tcons([],[tcons('Char',[])])]),tcons([],[tcons('Char',[])])]).
functiontype(reverse,[tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(enumFrom,[tcons('Int',[]),tcons([],[tcons('Int',[])])]).
functiontype(enumFromThen,[tcons('Int',[]),tcons('Int',[]),tcons([],[tcons('Int',[])])]).
functiontype(enumFromTo,[tcons('Int',[]),tcons('Int',[]),tcons([],[tcons('Int',[])])]).
functiontype(enumFromThenTo,[tcons('Int',[]),tcons('Int',[]),tcons('Int',[]),tcons([],[tcons('Int',[])])]).
functiontype(&>,[tcons('Success',[]),tcons('Success',[]),tcons('Success',[])]).
functiontype(failed,[tvar(A)]).
functiontype(maybe,[tvar(A),functype(tvar(B),tvar(A)),tcons('Maybe',[tvar(B)]),tvar(A)]).
functiontype(either,[functype(tvar(A),tvar(B)),functype(tvar(C),tvar(B)),tcons('Either',[tvar(A),tvar(C)]),tvar(B)]).
functiontype(putStr,[tcons([],[tcons('Char',[])]),tcons('IO',[tcons('()',[])])]).
functiontype(putStrLn,[tcons([],[tcons('Char',[])]),tcons('IO',[tcons('()',[])])]).
functiontype(getLine,[tcons('IO',[tcons([],[tcons('Char',[])])])]).
functiontype(print,[tvar(A),tcons('IO',[tcons('()',[])])]).
functiontype(doSolve,[tcons('Success',[]),tcons('IO',[tcons('()',[])])]).
functiontype(inject,[functype(tvar(A),tcons('Success',[])),functype(tvar(A),tcons('Success',[])),tvar(A),tcons('Success',[])]).
functiontype(all,[functype(tvar(A),tcons('Success',[])),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(all2,[functype(tvar(A),tcons('Success',[])),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(once,[functype(tvar(A),tcons('Success',[])),tvar(A),tcons('Success',[])]).
functiontype(tryone,[functype(tvar(A),tcons('Success',[])),tvar(A)]).
functiontype(one,[functype(tvar(A),tcons('Success',[])),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(condSearch,[functype(tvar(A),tcons('Success',[])),functype(tvar(A),tcons('Bool',[])),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(best,[functype(tvar(A),tcons('Success',[])),functype(tvar(A),functype(tvar(A),tcons('Bool',[]))),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(bestHelp,[tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))]),functype(tvar(A),functype(tvar(A),tcons('Bool',[]))),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(evalB,[tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))]),functype(tvar(A),functype(tvar(A),tcons('Bool',[]))),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(evalA,[tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))]),functype(tvar(A),functype(tvar(A),tcons('Bool',[]))),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(constrain,[functype(tvar(A),tcons('Success',[])),tcons([],[functype(tvar(B),tcons('Success',[]))]),functype(tvar(A),functype(tvar(B),tcons('Bool',[]))),tvar(A),tcons('Success',[])]).
functiontype(findall,[functype(tvar(A),tcons('Success',[])),tcons([],[tvar(A)])]).
functiontype(findfirst,[functype(tvar(A),tcons('Success',[])),tvar(A)]).
functiontype(dfs,[functype(tvar(A),tcons('Success',[])),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(browseList,[tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons('IO',[tcons('()',[])])]).
functiontype(unpack,[functype(tvar(A),tcons('Success',[])),tvar(A)]).
functiontype(prelude_lambda0_1663,[functype(tvar(A),tvar(B)),functype(tvar(C),tvar(A)),tvar(C),tvar(B)]).
functiontype(prelude_lambda1_1664,[tvar(A),tvar(B),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(B)])]),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(B)])])]).
functiontype(prelude_lambda2_1665,[tvar(A),tvar(B),tvar(C),tcons('(,,)',[tcons([],[tvar(A)]),tcons([],[tvar(B)]),tcons([],[tvar(C)])]),tcons('(,,)',[tcons([],[tvar(A)]),tcons([],[tvar(B)]),tcons([],[tvar(C)])])]).
functiontype(takep_343,[tcons('Int',[]),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(dropp_350,[tcons('Int',[]),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(splitAtp_357,[tcons('Int',[]),tcons([],[tvar(A)]),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(A)])])]).
functiontype(prelude_lambda3_1666,[tvar(A),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(A)])]),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(A)])])]).
functiontype(prelude_lambda4_1667,[tvar(A),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(A)])]),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(A)])])]).
functiontype(splitline_381,[tcons([],[tcons('Char',[])]),tcons('(,)',[tcons([],[tcons('Char',[])]),tcons([],[tcons('Char',[])])])]).
functiontype(prelude_lambda5_1668,[tcons('Char',[]),tcons('(,)',[tcons([],[tcons('Char',[])]),tcons([],[tcons('Char',[])])]),tcons('(,)',[tcons([],[tcons('Char',[])]),tcons([],[tcons('Char',[])])])]).
functiontype(prelude_lambda6_1669,[tcons('(,)',[tcons([],[tcons('Char',[])]),tcons([],[tcons('Char',[])])]),tcons([],[tcons([],[tcons('Char',[])])])]).
functiontype(prelude_lambda7_1670,[tcons([],[tcons('Char',[])]),tcons([],[tcons('Char',[])])]).
functiontype(prelude_lambda8_1671,[tcons('Int',[]),tcons('Int',[]),tcons('Int',[]),tcons('Int',[])]).
functiontype(p_399,[tcons('Int',[]),tcons('Int',[]),tcons('Int',[]),tcons('Int',[]),tcons('Bool',[])]).
functiontype(getLineReturn_418,[tcons('Char',[]),tcons([],[tcons('Char',[])]),tcons('IO',[tcons([],[tcons('Char',[])])])]).
functiontype(prelude_lambda9_1672,[tcons('Char',[]),tcons('IO',[tcons([],[tcons('Char',[])])])]).
functiontype(prelude_lambda10_1673,[functype(tvar(A),tcons('Success',[])),functype(tvar(A),tcons('Success',[])),tvar(A),tcons('Success',[])]).
functiontype(evalall_428,[tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(evalall2_429,[tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(evalall3_430,[tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(evalResult_445,[tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(prelude_lambda11_1674,[functype(tvar(A),tcons('Success',[])),tvar(A),tcons('Success',[])]).
functiontype(prelude_lambda12_1675,[functype(tvar(A),tcons('Success',[])),functype(tvar(A),tcons('Bool',[])),tvar(A),tcons('Success',[])]).
functiontype(prelude_lambda13_1676,[functype(tvar(A),tcons('Success',[])),functype(tvar(B),functype(tvar(A),tcons('Bool',[]))),tvar(B),tcons('Success',[])]).
functiontype(evaldfs_510,[tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(eval2_511,[tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(fun_geq,[tcons(fun_natural,[]),tcons(fun_natural,[]),tcons('Bool',[])]).
functiontype(fun_cip,[tcons([],[tvar(A)]),tcons([],[tvar(B)]),tcons([],[tcons('(,)',[tvar(A),tvar(B)])])]).
functiontype(fun_cip3,[tcons([],[tvar(A)]),tcons([],[tvar(B)]),tcons([],[tvar(C)]),tcons([],[tcons('(,,)',[tvar(A),tvar(B),tvar(C)])])]).
functiontype(fun_xor,[tcons('Bool',[]),tcons('Bool',[]),tcons('Bool',[])]).

functiontype('True',[tcons('Bool',[])]).
functiontype('False',[tcons('Bool',[])]).
functiontype('(,)',[tvar(A),tvar(B),tcons('(,)',[tvar(A),tvar(B)])]).
functiontype([],[tcons([],[tvar(A)])]).
functiontype('.',[tvar(A),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype('$io',[tvar(A),tcons('IO',[tvar(A)])]).
functiontype('()',[tcons('()',[])]).
functiontype(success,[tcons('Success',[])]).
functiontype('Nothing',[tcons('Maybe',[tvar(A)])]).
functiontype('Just',[tvar(A),tcons('Maybe',[tvar(A)])]).
functiontype('Left',[tvar(A),tcons('Either',[tvar(A),tvar(B)])]).
functiontype('Right',[tvar(A),tcons('Either',[tvar(B),tvar(A)])]).
functiontype(fun_zero,[tcons(fun_natural,[])]).
functiontype(fun_succ,[tcons(fun_natural,[]),tcons(fun_natural,[])]).
functiontype(fun_a,[tcons(fun_abc,[])]).
functiontype(fun_b,[tcons(fun_abc,[])]).
functiontype(fun_c,[tcons(fun_abc,[])]).

evaluation(==,'External'(==)).
evaluation(=:=,'External'(=:=)).
evaluation(success,'External'(success)).
evaluation('$comp','Rule'([0,1,2],'Apply'('Comb'('PartCall',prelude_lambda0_1663,['Var'(0),'Var'(1)]),'Var'(2)))).
evaluation(id,'Rule'([0],'Var'(0))).
evaluation(const,'Rule'([0,1],'Var'(0))).
evaluation(curry,'Rule'([0,1,2],'Apply'('Var'(0),'Comb'('ConsCall','(,)',['Var'(1),'Var'(2)])))).
evaluation(uncurry,'Rule'([0,1],'Case'('Rigid','Var'(1),['Pattern'('(,)',[2,3],'Apply'('Apply'('Var'(0),'Var'(2)),'Var'(3)))]))).
evaluation(flip,'Rule'([0,1,2],'Apply'('Apply'('Var'(0),'Var'(2)),'Var'(1)))).
evaluation($,'Rule'([0,1],'Apply'('Var'(0),'Var'(1)))).
evaluation(&&,'Rule'([0,1],'Case'('Rigid','Var'(0),['Pattern'('True',[],'Var'(1)),'Pattern'('False',[],'Comb'('ConsCall','False',[]))]))).
evaluation('||','Rule'([0,1],'Case'('Rigid','Var'(0),['Pattern'('True',[],'Comb'('ConsCall','True',[])),'Pattern'('False',[],'Var'(1))]))).
evaluation(not,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'('True',[],'Comb'('ConsCall','False',[])),'Pattern'('False',[],'Comb'('ConsCall','True',[]))]))).
evaluation(otherwise,'Rule'([],'Comb'('ConsCall','True',[]))).
evaluation(if_then_else,'Rule'([0,1,2],'Case'('Rigid','Var'(0),['Pattern'('True',[],'Var'(1)),'Pattern'('False',[],'Var'(2))]))).
evaluation(/=,'Rule'([0,1],'Comb'('FuncCall',not,['Comb'('FuncCall',==,['Var'(0),'Var'(1)])]))).
evaluation(fst,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'('(,)',[1,2],'Var'(1))]))).
evaluation(snd,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'('(,)',[1,2],'Var'(2))]))).
evaluation(head,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'('.',[1,2],'Var'(1))]))).
evaluation(tail,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'('.',[1,2],'Var'(2))]))).
evaluation(null,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'([],[],'Comb'('ConsCall','True',[])),'Pattern'('.',[1,2],'Comb'('ConsCall','False',[]))]))).
evaluation(++,'Rule'([0,1],'Case'('Rigid','Var'(0),['Pattern'([],[],'Var'(1)),'Pattern'('.',[2,3],'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall',++,['Var'(3),'Var'(1)])]))]))).
evaluation(length,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'([],[],'Lit'('Intc'(0))),'Pattern'('.',[1,2],'Comb'('FuncCall',+,['Lit'('Intc'(1)),'Comb'('FuncCall',length,['Var'(2)])]))]))).
evaluation('!!','Rule'([0,1],'Case'('Rigid','Var'(0),['Pattern'('.',[2,3],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',>,['Var'(1),'Lit'('Intc'(0))]),'Comb'('FuncCall','!!',['Var'(3),'Comb'('FuncCall',-,['Var'(1),'Lit'('Intc'(1))])]),'Var'(2)]))]))).
evaluation(map,'Rule'([0,1],'Case'('Rigid','Var'(1),['Pattern'([],[],'Comb'('ConsCall',[],[])),'Pattern'('.',[2,3],'Comb'('ConsCall','.',['Apply'('Var'(0),'Var'(2)),'Comb'('FuncCall',map,['Var'(0),'Var'(3)])]))]))).
evaluation(foldl,'Rule'([0,1,2],'Case'('Rigid','Var'(2),['Pattern'([],[],'Var'(1)),'Pattern'('.',[3,4],'Comb'('FuncCall',foldl,['Var'(0),'Apply'('Apply'('Var'(0),'Var'(1)),'Var'(3)),'Var'(4)]))]))).
evaluation(foldl1,'Rule'([0,1],'Case'('Rigid','Var'(1),['Pattern'('.',[2,3],'Comb'('FuncCall',foldl,['Var'(0),'Var'(2),'Var'(3)]))]))).
evaluation(foldr,'Rule'([0,1,2],'Case'('Rigid','Var'(2),['Pattern'([],[],'Var'(1)),'Pattern'('.',[3,4],'Apply'('Apply'('Var'(0),'Var'(3)),'Comb'('FuncCall',foldr,['Var'(0),'Var'(1),'Var'(4)])))]))).
evaluation(foldr1,'Rule'([0,1],'Case'('Rigid','Var'(1),['Pattern'('.',[2,3],'Case'('Rigid','Var'(3),['Pattern'([],[],'Var'(2)),'Pattern'('.',[4,5],'Apply'('Apply'('Var'(0),'Var'(2)),'Comb'('FuncCall',foldr1,['Var'(0),'Comb'('ConsCall','.',['Var'(4),'Var'(5)])])))]))]))).
evaluation(filter,'Rule'([0,1],'Case'('Rigid','Var'(1),['Pattern'([],[],'Comb'('ConsCall',[],[])),'Pattern'('.',[2,3],'Comb'('FuncCall',if_then_else,['Apply'('Var'(0),'Var'(2)),'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall',filter,['Var'(0),'Var'(3)])]),'Comb'('FuncCall',filter,['Var'(0),'Var'(3)])]))]))).
evaluation(zip,'Rule'([0,1],'Case'('Rigid','Var'(0),['Pattern'([],[],'Comb'('ConsCall',[],[])),'Pattern'('.',[2,3],'Case'('Rigid','Var'(1),['Pattern'([],[],'Comb'('ConsCall',[],[])),'Pattern'('.',[4,5],'Comb'('ConsCall','.',['Comb'('ConsCall','(,)',['Var'(2),'Var'(4)]),'Comb'('FuncCall',zip,['Var'(3),'Var'(5)])]))]))]))).
evaluation(zip3,'Rule'([0,1,2],'Case'('Rigid','Var'(0),['Pattern'([],[],'Comb'('ConsCall',[],[])),'Pattern'('.',[3,4],'Case'('Rigid','Var'(1),['Pattern'([],[],'Comb'('ConsCall',[],[])),'Pattern'('.',[5,6],'Case'('Rigid','Var'(2),['Pattern'([],[],'Comb'('ConsCall',[],[])),'Pattern'('.',[7,8],'Comb'('ConsCall','.',['Comb'('ConsCall','(,,)',['Var'(3),'Var'(5),'Var'(7)]),'Comb'('FuncCall',zip3,['Var'(4),'Var'(6),'Var'(8)])]))]))]))]))).
evaluation(unzip,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'([],[],'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[])])),'Pattern'('.',[1,2],'Case'('Rigid','Var'(1),['Pattern'('(,)',[3,4],'Comb'('FuncCall',prelude_lambda1_1664,['Var'(3),'Var'(4),'Comb'('FuncCall',unzip,['Var'(2)])]))]))]))).
evaluation(unzip3,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'([],[],'Comb'('ConsCall','(,,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[])])),'Pattern'('.',[1,2],'Case'('Rigid','Var'(1),['Pattern'('(,,)',[3,4,5],'Comb'('FuncCall',prelude_lambda2_1665,['Var'(3),'Var'(4),'Var'(5),'Comb'('FuncCall',unzip3,['Var'(2)])]))]))]))).
evaluation(concat,'Rule'([0],'Comb'('FuncCall',foldr,['Comb'('PartCall',++,[]),'Comb'('ConsCall',[],[]),'Var'(0)]))).
evaluation(concatMap,'Rule'([0,1],'Apply'('Comb'('FuncCall','$comp',['Comb'('PartCall',concat,[]),'Comb'('PartCall',map,['Var'(0)])]),'Var'(1)))).
evaluation(iterate,'Rule'([0,1],'Comb'('ConsCall','.',['Var'(1),'Comb'('FuncCall',iterate,['Var'(0),'Apply'('Var'(0),'Var'(1))])]))).
evaluation(repeat,'Rule'([0],'Comb'('ConsCall','.',['Var'(0),'Comb'('FuncCall',repeat,['Var'(0)])]))).
evaluation(replicate,'Rule'([0,1],'Comb'('FuncCall',take,['Var'(0),'Comb'('FuncCall',repeat,['Var'(1)])]))).
evaluation(take,'Rule'([0,1],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Lit'('Intc'(0))]),'Comb'('ConsCall',[],[]),'Comb'('FuncCall',takep_343,['Var'(0),'Var'(1)])]))).
evaluation(drop,'Rule'([0,1],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Lit'('Intc'(0))]),'Var'(1),'Comb'('FuncCall',dropp_350,['Var'(0),'Var'(1)])]))).
evaluation(splitAt,'Rule'([0,1],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Lit'('Intc'(0))]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Var'(1)]),'Comb'('FuncCall',splitAtp_357,['Var'(0),'Var'(1)])]))).
evaluation(takeWhile,'Rule'([0,1],'Case'('Rigid','Var'(1),['Pattern'([],[],'Comb'('ConsCall',[],[])),'Pattern'('.',[2,3],'Comb'('FuncCall',if_then_else,['Apply'('Var'(0),'Var'(2)),'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall',takeWhile,['Var'(0),'Var'(3)])]),'Comb'('ConsCall',[],[])]))]))).
evaluation(dropWhile,'Rule'([0,1],'Case'('Rigid','Var'(1),['Pattern'([],[],'Comb'('ConsCall',[],[])),'Pattern'('.',[2,3],'Comb'('FuncCall',if_then_else,['Apply'('Var'(0),'Var'(2)),'Comb'('FuncCall',dropWhile,['Var'(0),'Var'(3)]),'Comb'('ConsCall','.',['Var'(2),'Var'(3)])]))]))).
evaluation(span,'Rule'([0,1],'Case'('Rigid','Var'(1),['Pattern'([],[],'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[])])),'Pattern'('.',[2,3],'Comb'('FuncCall',if_then_else,['Apply'('Var'(0),'Var'(2)),'Comb'('FuncCall',prelude_lambda4_1667,['Var'(2),'Comb'('FuncCall',span,['Var'(0),'Var'(3)])]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall','.',['Var'(2),'Var'(3)])])]))]))).
evaluation(break,'Rule'([0,1],'Apply'('Comb'('PartCall',span,['Comb'('FuncCall','$comp',['Comb'('PartCall',not,[]),'Var'(0)])]),'Var'(1)))).
evaluation(lines,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'([],[],'Comb'('ConsCall',[],[])),'Pattern'('.',[1,2],'Comb'('FuncCall',prelude_lambda6_1669,['Comb'('FuncCall',splitline_381,['Comb'('ConsCall','.',['Var'(1),'Var'(2)])])]))]))).
evaluation(unlines,'Rule'([0],'Apply'('Comb'('FuncCall',concatMap,['Comb'('PartCall',prelude_lambda7_1670,[])]),'Var'(0)))).
evaluation(reverse,'Rule'([0],'Apply'('Comb'('PartCall',foldl,['Comb'('PartCall',flip,['Comb'('PartCall','.',[])]),'Comb'('ConsCall',[],[])]),'Var'(0)))).
evaluation(enumFrom,'Rule'([0],'Comb'('ConsCall','.',['Var'(0),'Comb'('FuncCall',enumFrom,['Comb'('FuncCall',+,['Var'(0),'Lit'('Intc'(1))])])]))).
evaluation(enumFromThen,'Rule'([0,1],'Comb'('FuncCall',iterate,['Comb'('PartCall',prelude_lambda8_1671,['Var'(1),'Var'(0)]),'Var'(0)]))).
evaluation(enumFromTo,'Rule'([0,1],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',>,['Var'(0),'Var'(1)]),'Comb'('ConsCall',[],[]),'Comb'('ConsCall','.',['Var'(0),'Comb'('FuncCall',enumFromTo,['Comb'('FuncCall',+,['Var'(0),'Lit'('Intc'(1))]),'Var'(1)])])]))).
evaluation(enumFromThenTo,'Rule'([0,1,2],'Comb'('FuncCall',takeWhile,['Comb'('PartCall',p_399,['Var'(1),'Var'(0),'Var'(2)]),'Comb'('FuncCall',enumFromThen,['Var'(0),'Var'(1)])]))).
evaluation(&>,'Rule'([0,1],'GuardedExpr'([],'Constr'([],'Var'(0)),'Var'(1)))).
evaluation(failed,'Rule'([],'GuardedExpr'([0],'Constr'([],'Comb'('FuncCall',=:=,['Lit'('Intc'(1)),'Lit'('Intc'(2))])),'Var'(0)))).
evaluation(maybe,'Rule'([0,1,2],'Case'('Rigid','Var'(2),['Pattern'('Nothing',[],'Var'(0)),'Pattern'('Just',[3],'Apply'('Var'(1),'Var'(3)))]))).
evaluation(either,'Rule'([0,1,2],'Case'('Rigid','Var'(2),['Pattern'('Left',[3],'Apply'('Var'(0),'Var'(3))),'Pattern'('Right',[4],'Apply'('Var'(1),'Var'(4)))]))).
evaluation(putStr,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'([],[],'Comb'('FuncCall',done,[])),'Pattern'('.',[1,2],'Comb'('FuncCall',>>,['Comb'('FuncCall',putChar,['Var'(1)]),'Comb'('FuncCall',putStr,['Var'(2)])]))]))).
evaluation(putStrLn,'Rule'([0],'Comb'('FuncCall',>>,['Comb'('FuncCall',putStr,['Var'(0)]),'Comb'('FuncCall',putChar,['Lit'('Charc'(10))])]))).
evaluation(getLine,'Rule'([],'Comb'('FuncCall',>>=,['Comb'('FuncCall',getChar,[]),'Comb'('PartCall',prelude_lambda9_1672,[])]))).
evaluation(print,'Rule'([0],'Comb'('FuncCall',putStrLn,['Comb'('FuncCall',show,['Var'(0)])]))).
evaluation(doSolve,'Rule'([0],'GuardedExpr'([],'Constr'([],'Var'(0)),'Comb'('FuncCall',done,[])))).
evaluation(inject,'Rule'([0,1,2],'Apply'('Comb'('PartCall',prelude_lambda10_1673,['Var'(1),'Var'(0)]),'Var'(2)))).
evaluation(all,'Rule'([0],'Comb'('FuncCall',evalall_428,['Comb'('FuncCall',try,['Var'(0)])]))).
evaluation(all2,'Rule'([0],'Comb'('FuncCall',evalResult_445,['Comb'('FuncCall',try,['Var'(0)])]))).
evaluation(once,'Rule'([0,1],'Apply'('Comb'('FuncCall',head,['Comb'('FuncCall',all,['Var'(0)])]),'Var'(1)))).
evaluation(one,'Rule'([0],'Comb'('FuncCall',dfs,['Comb'('PartCall',prelude_lambda11_1674,['Var'(0)])]))).
evaluation(condSearch,'Rule'([0,1],'Comb'('FuncCall',one,['Comb'('PartCall',prelude_lambda12_1675,['Var'(0),'Var'(1)])]))).
evaluation(best,'Rule'([0,1],'Comb'('FuncCall',bestHelp,['Comb'('ConsCall',[],[]),'Comb'('FuncCall',try,['Var'(0)]),'Comb'('ConsCall',[],[]),'Var'(1)]))).
evaluation(bestHelp,'Rule'([0,1,2,3],'Case'('Rigid','Var'(0),['Pattern'([],[],'Case'('Rigid','Var'(1),['Pattern'([],[],'Var'(2)),'Pattern'('.',[4,5],'Comb'('FuncCall',evalB,['Comb'('FuncCall',try,['Comb'('FuncCall',constrain,['Var'(4),'Var'(2),'Var'(3)])]),'Var'(5),'Var'(2),'Var'(3)]))])),'Pattern'('.',[6,7],'Comb'('FuncCall',evalA,['Comb'('FuncCall',try,['Var'(6)]),'Var'(7),'Var'(1),'Var'(2),'Var'(3)]))]))).
evaluation(evalB,'Rule'([0,1,2,3],'Case'('Rigid','Var'(0),['Pattern'([],[],'Comb'('FuncCall',bestHelp,['Comb'('ConsCall',[],[]),'Var'(1),'Var'(2),'Var'(3)])),'Pattern'('.',[4,5],'Case'('Rigid','Var'(5),['Pattern'([],[],'Comb'('FuncCall',bestHelp,['Comb'('ConsCall',[],[]),'Var'(1),'Comb'('ConsCall','.',['Var'(4),'Comb'('ConsCall',[],[])]),'Var'(3)])),'Pattern'('.',[6,7],'Comb'('FuncCall',bestHelp,['Comb'('ConsCall','.',['Var'(4),'Comb'('ConsCall','.',['Var'(6),'Var'(7)])]),'Var'(1),'Var'(2),'Var'(3)]))]))]))).
evaluation(evalA,'Rule'([0,1,2,3,4],'Case'('Rigid','Var'(0),['Pattern'([],[],'Comb'('FuncCall',bestHelp,['Var'(1),'Var'(2),'Var'(3),'Var'(4)])),'Pattern'('.',[5,6],'Case'('Rigid','Var'(6),['Pattern'([],[],'Comb'('FuncCall',bestHelp,['Comb'('ConsCall',[],[]),'Comb'('FuncCall',++,['Var'(1),'Var'(2)]),'Comb'('ConsCall','.',['Var'(5),'Comb'('ConsCall',[],[])]),'Var'(4)])),'Pattern'('.',[7,8],'Comb'('FuncCall',bestHelp,['Comb'('FuncCall',++,['Comb'('ConsCall','.',['Var'(5),'Comb'('ConsCall','.',['Var'(7),'Var'(8)])]),'Var'(1)]),'Var'(2),'Var'(3),'Var'(4)]))]))]))).
evaluation(constrain,'Rule'([0,1,2,5],'Case'('Flex','Var'(1),['Pattern'([],[],'Apply'('Var'(0),'Var'(5))),'Pattern'('.',[3,4],'Case'('Flex','Var'(4),['Pattern'([],[],'Apply'('Comb'('FuncCall',inject,['Var'(0),'Comb'('PartCall',prelude_lambda13_1676,['Var'(3),'Var'(2)])]),'Var'(5)))]))]))).
evaluation(dfs,'Rule'([0],'Comb'('FuncCall',evaldfs_510,['Comb'('FuncCall',try,['Var'(0)])]))).
evaluation(browseList,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'([],[],'Comb'('FuncCall',done,[])),'Pattern'('.',[1,2],'Comb'('FuncCall',>>,['Comb'('FuncCall',>>,['Comb'('FuncCall',browse,['Var'(1)]),'Comb'('FuncCall',putChar,['Lit'('Charc'(10))])]),'Comb'('FuncCall',browseList,['Var'(2)])]))]))).
evaluation(unpack,'Rule'([0],'GuardedExpr'([1],'Constr'([],'Apply'('Var'(0),'Var'(1))),'Var'(1)))).
evaluation(prelude_lambda0_1663,'Rule'([0,1,2],'Apply'('Var'(0),'Apply'('Var'(1),'Var'(2))))).
evaluation(prelude_lambda1_1664,'Rule'([0,1,2],'Case'('Rigid','Var'(2),['Pattern'('(,)',[3,4],'Comb'('ConsCall','(,)',['Comb'('ConsCall','.',['Var'(0),'Var'(3)]),'Comb'('ConsCall','.',['Var'(1),'Var'(4)])]))]))).
evaluation(prelude_lambda2_1665,'Rule'([0,1,2,3],'Case'('Rigid','Var'(3),['Pattern'('(,,)',[4,5,6],'Comb'('ConsCall','(,,)',['Comb'('ConsCall','.',['Var'(0),'Var'(4)]),'Comb'('ConsCall','.',['Var'(1),'Var'(5)]),'Comb'('ConsCall','.',['Var'(2),'Var'(6)])]))]))).
evaluation(takep_343,'Rule'([0,1],'Case'('Rigid','Var'(1),['Pattern'([],[],'Comb'('ConsCall',[],[])),'Pattern'('.',[2,3],'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall',take,['Comb'('FuncCall',-,['Var'(0),'Lit'('Intc'(1))]),'Var'(3)])]))]))).
evaluation(dropp_350,'Rule'([0,1],'Case'('Rigid','Var'(1),['Pattern'([],[],'Comb'('ConsCall',[],[])),'Pattern'('.',[2,3],'Comb'('FuncCall',drop,['Comb'('FuncCall',-,['Var'(0),'Lit'('Intc'(1))]),'Var'(3)]))]))).
evaluation(splitAtp_357,'Rule'([0,1],'Case'('Rigid','Var'(1),['Pattern'([],[],'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[])])),'Pattern'('.',[2,3],'Comb'('FuncCall',prelude_lambda3_1666,['Var'(2),'Comb'('FuncCall',splitAt,['Comb'('FuncCall',-,['Var'(0),'Lit'('Intc'(1))]),'Var'(3)])]))]))).
evaluation(prelude_lambda3_1666,'Rule'([0,1],'Case'('Rigid','Var'(1),['Pattern'('(,)',[2,3],'Comb'('ConsCall','(,)',['Comb'('ConsCall','.',['Var'(0),'Var'(2)]),'Var'(3)]))]))).
evaluation(prelude_lambda4_1667,'Rule'([0,1],'Case'('Rigid','Var'(1),['Pattern'('(,)',[2,3],'Comb'('ConsCall','(,)',['Comb'('ConsCall','.',['Var'(0),'Var'(2)]),'Var'(3)]))]))).
evaluation(splitline_381,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'([],[],'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[])])),'Pattern'('.',[1,2],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(1),'Lit'('Charc'(10))]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Var'(2)]),'Comb'('FuncCall',prelude_lambda5_1668,['Var'(1),'Comb'('FuncCall',splitline_381,['Var'(2)])])]))]))).
evaluation(prelude_lambda5_1668,'Rule'([0,1],'Case'('Rigid','Var'(1),['Pattern'('(,)',[2,3],'Comb'('ConsCall','(,)',['Comb'('ConsCall','.',['Var'(0),'Var'(2)]),'Var'(3)]))]))).
evaluation(prelude_lambda6_1669,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'('(,)',[1,2],'Comb'('ConsCall','.',['Var'(1),'Comb'('FuncCall',lines,['Var'(2)])]))]))).
evaluation(prelude_lambda7_1670,'Rule'([0],'Comb'('FuncCall',++,['Var'(0),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])])]))).
evaluation(prelude_lambda8_1671,'Rule'([0,1,2],'Comb'('FuncCall',+,['Comb'('FuncCall',-,['Var'(0),'Var'(1)]),'Var'(2)]))).
evaluation(p_399,'Rule'([0,1,2,3],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',>=,['Var'(0),'Var'(1)]),'Comb'('FuncCall',<=,['Var'(3),'Var'(2)]),'Comb'('FuncCall',>=,['Var'(3),'Var'(2)])]))).
evaluation(getLineReturn_418,'Rule'([0,1],'Comb'('FuncCall',return,['Comb'('ConsCall','.',['Var'(0),'Var'(1)])]))).
evaluation(prelude_lambda9_1672,'Rule'([0],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Lit'('Charc'(10))]),'Comb'('FuncCall',return,['Comb'('ConsCall',[],[])]),'Comb'('FuncCall',>>=,['Comb'('FuncCall',getLine,[]),'Comb'('PartCall',getLineReturn_418,['Var'(0)])])]))).
evaluation(prelude_lambda10_1673,'Rule'([0,1,2],'Comb'('FuncCall',&,['Apply'('Var'(0),'Var'(2)),'Apply'('Var'(1),'Var'(2))]))).
evaluation(evalall_428,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'([],[],'Comb'('ConsCall',[],[])),'Pattern'('.',[1,2],'Case'('Rigid','Var'(2),['Pattern'([],[],'Comb'('ConsCall','.',['Var'(1),'Comb'('ConsCall',[],[])])),'Pattern'('.',[3,4],'Comb'('FuncCall',evalall3_430,['Comb'('FuncCall',try,['Var'(1)]),'Comb'('ConsCall','.',['Var'(3),'Var'(4)])]))]))]))).
evaluation(evalall2_429,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'([],[],'Comb'('ConsCall',[],[])),'Pattern'('.',[1,2],'Comb'('FuncCall',evalall3_430,['Comb'('FuncCall',try,['Var'(1)]),'Var'(2)]))]))).
evaluation(evalall3_430,'Rule'([0,1],'Case'('Rigid','Var'(0),['Pattern'([],[],'Comb'('FuncCall',evalall2_429,['Var'(1)])),'Pattern'('.',[2,3],'Case'('Rigid','Var'(3),['Pattern'([],[],'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall',evalall2_429,['Var'(1)])])),'Pattern'('.',[4,5],'Comb'('FuncCall',evalall3_430,['Comb'('FuncCall',try,['Var'(2)]),'Comb'('ConsCall','.',['Var'(4),'Comb'('FuncCall',++,['Var'(5),'Var'(1)])])]))]))]))).
evaluation(evalResult_445,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'([],[],'Comb'('ConsCall',[],[])),'Pattern'('.',[1,2],'Case'('Rigid','Var'(2),['Pattern'([],[],'Comb'('ConsCall','.',['Var'(1),'Comb'('ConsCall',[],[])])),'Pattern'('.',[3,4],'Comb'('FuncCall',concat,['Comb'('FuncCall',map,['Comb'('PartCall',all2,[]),'Comb'('ConsCall','.',['Var'(1),'Comb'('ConsCall','.',['Var'(3),'Var'(4)])])])]))]))]))).
evaluation(prelude_lambda11_1674,'Rule'([0,1],'Comb'('FuncCall',=:=,['Var'(1),'Comb'('FuncCall',tryone,['Var'(0)])]))).
evaluation(prelude_lambda12_1675,'Rule'([0,1,2],'Comb'('FuncCall',&,['Apply'('Var'(0),'Var'(2)),'Comb'('FuncCall',=:=,['Apply'('Var'(1),'Var'(2)),'Comb'('ConsCall','True',[])])]))).
evaluation(prelude_lambda13_1676,'Rule'([0,1,2],'Constr'([3],'Comb'('FuncCall',&,['Apply'('Var'(0),'Var'(3)),'Comb'('FuncCall',=:=,['Apply'('Apply'('Var'(1),'Var'(2)),'Var'(3)),'Comb'('ConsCall','True',[])])])))).
evaluation(evaldfs_510,'Rule'([0],'Case'('Rigid','Var'(0),['Pattern'([],[],'Comb'('ConsCall',[],[])),'Pattern'('.',[1,2],'Comb'('FuncCall',eval2_511,['Comb'('FuncCall',try,['Var'(1)]),'Var'(2)]))]))).
evaluation(eval2_511,'Rule'([0,1],'Case'('Rigid','Var'(0),['Pattern'([],[],'Comb'('FuncCall',evaldfs_510,['Var'(1)])),'Pattern'('.',[2,3],'Case'('Rigid','Var'(3),['Pattern'([],[],'Comb'('ConsCall','.',['Var'(2),'Comb'('ConsCall',[],[])])),'Pattern'('.',[4,5],'Comb'('FuncCall',eval2_511,['Comb'('FuncCall',try,['Var'(2)]),'Comb'('ConsCall','.',['Var'(4),'Comb'('FuncCall',++,['Var'(5),'Var'(1)])])]))]))]))).
evaluation(fun_geq,'Rule'([0,1],'Case'('Rigid','Var'(0),['Pattern'(fun_zero,[],'Case'('Rigid','Var'(1),['Pattern'(fun_zero,[],'Comb'('ConsCall','True',[])),'Pattern'(fun_succ,[2],'Comb'('ConsCall','False',[]))])),'Pattern'(fun_succ,[3],'Case'('Rigid','Var'(1),['Pattern'(fun_zero,[],'Comb'('ConsCall','True',[])),'Pattern'(fun_succ,[4],'Comb'('FuncCall',fun_geq,['Var'(3),'Var'(4)]))]))]))).
evaluation(fun_cip,'Rule'([0,1],'Case'('Rigid','Var'(0),['Pattern'([],[],'Case'('Rigid','Var'(1),['Pattern'([],[],'Comb'('ConsCall',[],[]))])),'Pattern'('.',[2,3],'Case'('Rigid','Var'(1),['Pattern'('.',[4,5],'Comb'('ConsCall','.',['Comb'('ConsCall','(,)',['Var'(2),'Var'(4)]),'Comb'('FuncCall',fun_cip,['Var'(3),'Var'(5)])]))]))]))).
evaluation(fun_cip3,'Rule'([0,1,2],'Case'('Rigid','Var'(0),['Pattern'([],[],'Case'('Rigid','Var'(1),['Pattern'([],[],'Case'('Rigid','Var'(2),['Pattern'([],[],'Comb'('ConsCall',[],[]))]))])),'Pattern'('.',[3,4],'Case'('Rigid','Var'(1),['Pattern'('.',[5,6],'Case'('Rigid','Var'(2),['Pattern'('.',[7,8],'Comb'('ConsCall','.',['Comb'('ConsCall','(,,)',['Var'(3),'Var'(5),'Var'(7)]),'Comb'('FuncCall',fun_cip3,['Var'(4),'Var'(6),'Var'(8)])]))]))]))]))).
evaluation(fun_xor,'Rule'([0,1],'Case'('Rigid','Var'(0),['Pattern'('True',[],'Case'('Rigid','Var'(1),['Pattern'('True',[],'Comb'('ConsCall','False',[])),'Pattern'('False',[],'Comb'('ConsCall','True',[]))])),'Pattern'('False',[],'Case'('Rigid','Var'(1),['Pattern'('True',[],'Comb'('ConsCall','True',[])),'Pattern'('False',[],'Comb'('ConsCall','False',[]))]))]))).




%%%%% Number of shared variables: 41
